//////////////////////////////////////////////////////////////////////
// Created by Actel CoreConsole - Mon Mar 24 12:15:12 2008
//////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module ProcessorSystem(
    // Inputs
    ExternalMemIf_MEMACKI,
    ExternalMemIf_MEMDATAI,
    ExternalMemIf_MEMPSACKI,
    GP_IN,
    NSYSRESET,
    RX,
    SYSCLK,
    // Outputs
    ExternalMemIf_MEMADDR,
    ExternalMemIf_MEMDATAO,
    ExternalMemIf_MEMPSRD,
    ExternalMemIf_MEMRD,
    ExternalMemIf_MEMWR,
    GP_OUT,
    RESETN,
    TX
);

//--------------------------------------------------------------------
// Inputs
//--------------------------------------------------------------------

input ExternalMemIf_MEMACKI;
input [7:0] ExternalMemIf_MEMDATAI;
input ExternalMemIf_MEMPSACKI;
input [15:0] GP_IN;
input NSYSRESET;
input RX;
input SYSCLK;

//--------------------------------------------------------------------
// Outputs
//--------------------------------------------------------------------

output [15:0] ExternalMemIf_MEMADDR;
output [7:0] ExternalMemIf_MEMDATAO;
output ExternalMemIf_MEMPSRD;
output ExternalMemIf_MEMRD;
output ExternalMemIf_MEMWR;
output [15:0] GP_OUT;
output RESETN;
output TX;

//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------

wire [23:0] Autostitch_APB3mmaster_PADDR;
wire Autostitch_APB3mmaster_PENABLE;
wire [31:0] Autostitch_APB3mmaster_PRDATA;
wire Autostitch_APB3mmaster_PREADY;
wire Autostitch_APB3mmaster_PSEL;
wire Autostitch_APB3mmaster_PSLVERR;
wire [31:0] Autostitch_APB3mmaster_PWDATA;
wire Autostitch_APB3mmaster_PWRITE;
wire [31:0] Autostitch_APBmslave4_PRDATA;
wire Autostitch_APBmslave4_PSELx;
wire [31:0] Autostitch_APBmslave6_PRDATA;
wire Autostitch_APBmslave6_PSELx;
wire [23:0] CoreAPB3_00_PADDRS;
wire CoreAPB3_00_PENABLES;
wire [31:0] CoreAPB3_00_PWDATAS;
wire CoreAPB3_00_PWRITES;

//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------

CORE8051S #(
        // Configuration parameters
        .APB_DWIDTH('d16), 
        .EN_FF_OPTS(0), 
        .FAMILY('d17), 
        .INCL_DPTR1(0), 
        .INCL_MUL_DIV_DA(0), 
        .INCL_TRACE(0), 
        .STRETCH_VAL(0), 
        .TRIG_NUM('d4), 
        .USE_OCI(0), 
        .USE_UJTAG(1), 
        .VARIABLE_STRETCH(0), 
        .VARIABLE_WAIT(1), 
        .WAIT_VAL(0)
    )
    Core8051s_00(
        // Inputs
        .BREAKIN({1{1'b0}}),
        .CLK(SYSCLK),
        .INT0({1{1'b0}}),
        .INT1({1{1'b0}}),
        .MEMACKI(ExternalMemIf_MEMACKI),
        .MEMBANK({4{1'b0}}),
        .MEMDATAI(ExternalMemIf_MEMDATAI),
        .MEMPSACKI(ExternalMemIf_MEMPSACKI),
        .NSYSRESET(NSYSRESET),
        .PRDATA(Autostitch_APB3mmaster_PRDATA[15:0]),
        .PREADY(Autostitch_APB3mmaster_PREADY),
        .PSLVERR(Autostitch_APB3mmaster_PSLVERR),
        .TCK({1{1'b1}}),
        .TDI({1{1'b0}}),
        .TMS({1{1'b0}}),
        .TRSTN({1{1'b1}}),
        .WDOGRES({1{1'b0}}),
        // Outputs
        .AUXOUT(),
        .BREAKOUT(),
        .DBGMEMPSWR(),
        .MEMADDR(ExternalMemIf_MEMADDR),
        .MEMDATAO(ExternalMemIf_MEMDATAO),
        .MEMPSRD(ExternalMemIf_MEMPSRD),
        .MEMRD(ExternalMemIf_MEMRD),
        .MEMWR(ExternalMemIf_MEMWR),
        .MOVX(),
        .PADDR(Autostitch_APB3mmaster_PADDR[11:0]),
        .PENABLE(Autostitch_APB3mmaster_PENABLE),
        .PRESETN(RESETN),
        .PSEL(Autostitch_APB3mmaster_PSEL),
        .PWDATA(Autostitch_APB3mmaster_PWDATA[15:0]),
        .PWRITE(Autostitch_APB3mmaster_PWRITE),
        .TDO(),
        .TRIGOUT(),
        .WDOGRESN()
    );

//--------------------------------------------------------------------

CoreAPB3 #(
        // Configuration parameters
        .ApbSlot0Enable(0), 
        .ApbSlot10Enable(0), 
        .ApbSlot11Enable(0), 
        .ApbSlot12Enable(0), 
        .ApbSlot13Enable(0), 
        .ApbSlot14Enable(0), 
        .ApbSlot15Enable(0), 
        .ApbSlot1Enable(0), 
        .ApbSlot2Enable(0), 
        .ApbSlot3Enable(0), 
        .ApbSlot4Enable(1), 
        .ApbSlot5Enable(0), 
        .ApbSlot6Enable(1), 
        .ApbSlot7Enable(0), 
        .ApbSlot8Enable(0), 
        .ApbSlot9Enable(0), 
        .RangeSize('d256)
    )
    CoreAPB3_00(
        // Inputs
        .PADDR(Autostitch_APB3mmaster_PADDR),
        .PENABLE(Autostitch_APB3mmaster_PENABLE),
        .PRDATAS0({32{1'b0}}),
        .PRDATAS1({32{1'b0}}),
        .PRDATAS10({32{1'b0}}),
        .PRDATAS11({32{1'b0}}),
        .PRDATAS12({32{1'b0}}),
        .PRDATAS13({32{1'b0}}),
        .PRDATAS14({32{1'b0}}),
        .PRDATAS15({32{1'b0}}),
        .PRDATAS2({32{1'b0}}),
        .PRDATAS3({32{1'b0}}),
        .PRDATAS4(Autostitch_APBmslave4_PRDATA),
        .PRDATAS5({32{1'b0}}),
        .PRDATAS6(Autostitch_APBmslave6_PRDATA),
        .PRDATAS7({32{1'b0}}),
        .PRDATAS8({32{1'b0}}),
        .PRDATAS9({32{1'b0}}),
        .PREADYS0({1{1'b1}}),
        .PREADYS1({1{1'b1}}),
        .PREADYS10({1{1'b1}}),
        .PREADYS11({1{1'b1}}),
        .PREADYS12({1{1'b1}}),
        .PREADYS13({1{1'b1}}),
        .PREADYS14({1{1'b1}}),
        .PREADYS15({1{1'b1}}),
        .PREADYS2({1{1'b1}}),
        .PREADYS3({1{1'b1}}),
        .PREADYS4({1{1'b1}}),
        .PREADYS5({1{1'b1}}),
        .PREADYS6({1{1'b1}}),
        .PREADYS7({1{1'b1}}),
        .PREADYS8({1{1'b1}}),
        .PREADYS9({1{1'b1}}),
        .PSEL(Autostitch_APB3mmaster_PSEL),
        .PSLVERRS0({1{1'b0}}),
        .PSLVERRS1({1{1'b0}}),
        .PSLVERRS10({1{1'b0}}),
        .PSLVERRS11({1{1'b0}}),
        .PSLVERRS12({1{1'b0}}),
        .PSLVERRS13({1{1'b0}}),
        .PSLVERRS14({1{1'b0}}),
        .PSLVERRS15({1{1'b0}}),
        .PSLVERRS2({1{1'b0}}),
        .PSLVERRS3({1{1'b0}}),
        .PSLVERRS4({1{1'b0}}),
        .PSLVERRS5({1{1'b0}}),
        .PSLVERRS6({1{1'b0}}),
        .PSLVERRS7({1{1'b0}}),
        .PSLVERRS8({1{1'b0}}),
        .PSLVERRS9({1{1'b0}}),
        .PWDATA(Autostitch_APB3mmaster_PWDATA),
        .PWRITE(Autostitch_APB3mmaster_PWRITE),
        // Outputs
        .PADDRS(CoreAPB3_00_PADDRS),
        .PENABLES(CoreAPB3_00_PENABLES),
        .PRDATA(Autostitch_APB3mmaster_PRDATA),
        .PREADY(Autostitch_APB3mmaster_PREADY),
        .PSELS0(),
        .PSELS1(),
        .PSELS10(),
        .PSELS11(),
        .PSELS12(),
        .PSELS13(),
        .PSELS14(),
        .PSELS15(),
        .PSELS2(),
        .PSELS3(),
        .PSELS4(Autostitch_APBmslave4_PSELx),
        .PSELS5(),
        .PSELS6(Autostitch_APBmslave6_PSELx),
        .PSELS7(),
        .PSELS8(),
        .PSELS9(),
        .PSLVERR(Autostitch_APB3mmaster_PSLVERR),
        .PWDATAS(CoreAPB3_00_PWDATAS),
        .PWRITES(CoreAPB3_00_PWRITES)
    );

//--------------------------------------------------------------------

CoreGPIO #(
        // Configuration parameters
        .NUM_INPUTS('d16), 
        .NUM_OUTPUTS('d16)
    )
    CoreGPIO_00(
        // Inputs
        .PADDR(CoreAPB3_00_PADDRS[5:2]),
        .PCLK(SYSCLK),
        .PENABLE(CoreAPB3_00_PENABLES),
        .PRESETn(RESETN),
        .PSEL(Autostitch_APBmslave4_PSELx),
        .PWDATA(CoreAPB3_00_PWDATAS),
        .PWRITE(CoreAPB3_00_PWRITES),
        .dataIn(GP_IN),
        // Outputs
        .PRDATA(Autostitch_APBmslave4_PRDATA),
        .dataOut(GP_OUT)
    );

//--------------------------------------------------------------------

CoreUARTapb #(
        // Configuration parameters
        .ASYNCHRONOUS(1), 
        .RX_FIFO(0), 
        .TX_FIFO(0)
    )
    CoreUARTapb_00(
        // Inputs
        .PADDR(CoreAPB3_00_PADDRS[4:2]),
        .PCLK(SYSCLK),
        .PENABLE(CoreAPB3_00_PENABLES),
        .PRESETn(RESETN),
        .PSEL(Autostitch_APBmslave6_PSELx),
        .PWDATA(CoreAPB3_00_PWDATAS[7:0]),
        .PWRITE(CoreAPB3_00_PWRITES),
        .rx(RX),
        // Outputs
        .PRDATA(Autostitch_APBmslave6_PRDATA[7:0]),
        .receive_full(),
        .tx(TX),
        .txrdy()
    );

//--------------------------------------------------------------------
// Drive unused bits of nets to 0
//--------------------------------------------------------------------

assign Autostitch_APB3mmaster_PADDR[23:12] = {12{1'b0}};
assign Autostitch_APB3mmaster_PWDATA[31:16] = {16{1'b0}};
assign Autostitch_APBmslave6_PRDATA[31:8] = {24{1'b0}};

endmodule

