----------------------------------------------------------------------
-- Created by Actel CoreConsole - Mon Mar 24 12:15:12 2008
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

----------------------------------------------------------------------
-- ProcessorSystem entity declaration
----------------------------------------------------------------------

entity ProcessorSystem is
    -- Port list
    port(
        -- Inputs
        ExternalMemIf_MEMACKI : in std_logic;
        ExternalMemIf_MEMDATAI : in std_logic_vector(7 downto 0);
        ExternalMemIf_MEMPSACKI : in std_logic;
        GP_IN : in std_logic_vector(15 downto 0);
        NSYSRESET : in std_logic;
        RX : in std_logic;
        SYSCLK : in std_logic;
        -- Outputs
        ExternalMemIf_MEMADDR : out std_logic_vector(15 downto 0);
        ExternalMemIf_MEMDATAO : out std_logic_vector(7 downto 0);
        ExternalMemIf_MEMPSRD : out std_logic;
        ExternalMemIf_MEMRD : out std_logic;
        ExternalMemIf_MEMWR : out std_logic;
        GP_OUT : out std_logic_vector(15 downto 0);
        RESETN : out std_logic;
        TX : out std_logic
    );
end ProcessorSystem;

----------------------------------------------------------------------
-- ProcessorSystem architecture body
----------------------------------------------------------------------

architecture RTL of ProcessorSystem is 

    --
    -- Component declarations
    --

    -- CORE8051S
    component CORE8051S
        -- Configuration generics
        generic(
            APB_DWIDTH : integer := 16;
            EN_FF_OPTS : integer := 0;
            FAMILY : integer := 17;
            INCL_DPTR1 : integer := 0;
            INCL_MUL_DIV_DA : integer := 0;
            INCL_TRACE : integer := 0;
            STRETCH_VAL : integer := 0;
            TRIG_NUM : integer := 4;
            USE_OCI : integer := 0;
            USE_UJTAG : integer := 1;
            VARIABLE_STRETCH : integer := 0;
            VARIABLE_WAIT : integer := 1;
            WAIT_VAL : integer := 0
        );
        -- Port list
        port(
            -- Inputs
            BREAKIN : in std_logic;
            CLK : in std_logic;
            INT0 : in std_logic;
            INT1 : in std_logic;
            MEMACKI : in std_logic;
            MEMBANK : in std_logic_vector(3 downto 0);
            MEMDATAI : in std_logic_vector(7 downto 0);
            MEMPSACKI : in std_logic;
            NSYSRESET : in std_logic;
            PRDATA : in std_logic_vector(15 downto 0);
            PREADY : in std_logic;
            PSLVERR : in std_logic;
            TCK : in std_logic;
            TDI : in std_logic;
            TMS : in std_logic;
            TRSTN : in std_logic;
            WDOGRES : in std_logic;
            -- Outputs
            AUXOUT : out std_logic;
            BREAKOUT : out std_logic;
            DBGMEMPSWR : out std_logic;
            MEMADDR : out std_logic_vector(15 downto 0);
            MEMDATAO : out std_logic_vector(7 downto 0);
            MEMPSRD : out std_logic;
            MEMRD : out std_logic;
            MEMWR : out std_logic;
            MOVX : out std_logic;
            PADDR : out std_logic_vector(11 downto 0);
            PENABLE : out std_logic;
            PRESETN : out std_logic;
            PSEL : out std_logic;
            PWDATA : out std_logic_vector(15 downto 0);
            PWRITE : out std_logic;
            TDO : out std_logic;
            TRIGOUT : out std_logic;
            WDOGRESN : out std_logic
        );
    end component;

    -- CoreAPB3
    component CoreAPB3
        -- Configuration generics
        generic(
            ApbSlot0Enable : integer := 0;
            ApbSlot10Enable : integer := 0;
            ApbSlot11Enable : integer := 0;
            ApbSlot12Enable : integer := 0;
            ApbSlot13Enable : integer := 0;
            ApbSlot14Enable : integer := 0;
            ApbSlot15Enable : integer := 0;
            ApbSlot1Enable : integer := 0;
            ApbSlot2Enable : integer := 0;
            ApbSlot3Enable : integer := 0;
            ApbSlot4Enable : integer := 1;
            ApbSlot5Enable : integer := 0;
            ApbSlot6Enable : integer := 1;
            ApbSlot7Enable : integer := 0;
            ApbSlot8Enable : integer := 0;
            ApbSlot9Enable : integer := 0;
            RangeSize : integer := 256
        );
        -- Port list
        port(
            -- Inputs
            PADDR : in std_logic_vector(23 downto 0);
            PENABLE : in std_logic;
            PRDATAS0 : in std_logic_vector(31 downto 0);
            PRDATAS1 : in std_logic_vector(31 downto 0);
            PRDATAS10 : in std_logic_vector(31 downto 0);
            PRDATAS11 : in std_logic_vector(31 downto 0);
            PRDATAS12 : in std_logic_vector(31 downto 0);
            PRDATAS13 : in std_logic_vector(31 downto 0);
            PRDATAS14 : in std_logic_vector(31 downto 0);
            PRDATAS15 : in std_logic_vector(31 downto 0);
            PRDATAS2 : in std_logic_vector(31 downto 0);
            PRDATAS3 : in std_logic_vector(31 downto 0);
            PRDATAS4 : in std_logic_vector(31 downto 0);
            PRDATAS5 : in std_logic_vector(31 downto 0);
            PRDATAS6 : in std_logic_vector(31 downto 0);
            PRDATAS7 : in std_logic_vector(31 downto 0);
            PRDATAS8 : in std_logic_vector(31 downto 0);
            PRDATAS9 : in std_logic_vector(31 downto 0);
            PREADYS0 : in std_logic;
            PREADYS1 : in std_logic;
            PREADYS10 : in std_logic;
            PREADYS11 : in std_logic;
            PREADYS12 : in std_logic;
            PREADYS13 : in std_logic;
            PREADYS14 : in std_logic;
            PREADYS15 : in std_logic;
            PREADYS2 : in std_logic;
            PREADYS3 : in std_logic;
            PREADYS4 : in std_logic;
            PREADYS5 : in std_logic;
            PREADYS6 : in std_logic;
            PREADYS7 : in std_logic;
            PREADYS8 : in std_logic;
            PREADYS9 : in std_logic;
            PSEL : in std_logic;
            PSLVERRS0 : in std_logic;
            PSLVERRS1 : in std_logic;
            PSLVERRS10 : in std_logic;
            PSLVERRS11 : in std_logic;
            PSLVERRS12 : in std_logic;
            PSLVERRS13 : in std_logic;
            PSLVERRS14 : in std_logic;
            PSLVERRS15 : in std_logic;
            PSLVERRS2 : in std_logic;
            PSLVERRS3 : in std_logic;
            PSLVERRS4 : in std_logic;
            PSLVERRS5 : in std_logic;
            PSLVERRS6 : in std_logic;
            PSLVERRS7 : in std_logic;
            PSLVERRS8 : in std_logic;
            PSLVERRS9 : in std_logic;
            PWDATA : in std_logic_vector(31 downto 0);
            PWRITE : in std_logic;
            -- Outputs
            PADDRS : out std_logic_vector(23 downto 0);
            PENABLES : out std_logic;
            PRDATA : out std_logic_vector(31 downto 0);
            PREADY : out std_logic;
            PSELS0 : out std_logic;
            PSELS1 : out std_logic;
            PSELS10 : out std_logic;
            PSELS11 : out std_logic;
            PSELS12 : out std_logic;
            PSELS13 : out std_logic;
            PSELS14 : out std_logic;
            PSELS15 : out std_logic;
            PSELS2 : out std_logic;
            PSELS3 : out std_logic;
            PSELS4 : out std_logic;
            PSELS5 : out std_logic;
            PSELS6 : out std_logic;
            PSELS7 : out std_logic;
            PSELS8 : out std_logic;
            PSELS9 : out std_logic;
            PSLVERR : out std_logic;
            PWDATAS : out std_logic_vector(31 downto 0);
            PWRITES : out std_logic
        );
    end component;

    -- CoreGPIO
    component CoreGPIO
        -- Configuration generics
        generic(
            NUM_INPUTS : integer := 16;
            NUM_OUTPUTS : integer := 16
        );
        -- Port list
        port(
            -- Inputs
            PADDR : in std_logic_vector(5 downto 2);
            PCLK : in std_logic;
            PENABLE : in std_logic;
            PRESETn : in std_logic;
            PSEL : in std_logic;
            PWDATA : in std_logic_vector(31 downto 0);
            PWRITE : in std_logic;
            dataIn : in std_logic_vector(15 downto 0);
            -- Outputs
            PRDATA : out std_logic_vector(31 downto 0);
            dataOut : out std_logic_vector(15 downto 0)
        );
    end component;

    -- CoreUARTapb
    component CoreUARTapb
        -- Configuration generics
        generic(
            ASYNCHRONOUS : integer := 1;
            RX_FIFO : integer := 0;
            TX_FIFO : integer := 0
        );
        -- Port list
        port(
            -- Inputs
            PADDR : in std_logic_vector(4 downto 2);
            PCLK : in std_logic;
            PENABLE : in std_logic;
            PRESETn : in std_logic;
            PSEL : in std_logic;
            PWDATA : in std_logic_vector(7 downto 0);
            PWRITE : in std_logic;
            rx : in std_logic;
            -- Outputs
            PRDATA : out std_logic_vector(7 downto 0);
            receive_full : out std_logic;
            tx : out std_logic;
            txrdy : out std_logic
        );
    end component;

    --
    -- Signal declarations
    --

    signal Autostitch_APB3mmaster_PADDR : std_logic_vector(23 downto 0);
    signal Autostitch_APB3mmaster_PENABLE : std_logic;
    signal Autostitch_APB3mmaster_PRDATA : std_logic_vector(31 downto 0);
    signal Autostitch_APB3mmaster_PREADY : std_logic;
    signal Autostitch_APB3mmaster_PSEL : std_logic;
    signal Autostitch_APB3mmaster_PSLVERR : std_logic;
    signal Autostitch_APB3mmaster_PWDATA : std_logic_vector(31 downto 0);
    signal Autostitch_APB3mmaster_PWRITE : std_logic;
    signal Autostitch_APBmslave4_PRDATA : std_logic_vector(31 downto 0);
    signal Autostitch_APBmslave4_PSELx : std_logic;
    signal Autostitch_APBmslave6_PRDATA : std_logic_vector(31 downto 0);
    signal Autostitch_APBmslave6_PSELx : std_logic;
    signal CoreAPB3_00_PADDRS : std_logic_vector(23 downto 0);
    signal CoreAPB3_00_PENABLES : std_logic;
    signal CoreAPB3_00_PWDATAS : std_logic_vector(31 downto 0);
    signal CoreAPB3_00_PWRITES : std_logic;

    signal iRESETN : std_logic;

begin

    --
    -- Signal assignments
    --

    RESETN <= iRESETN;

    -- Drive unused bits of nets to 0
    Autostitch_APB3mmaster_PADDR(23 downto 12) <= (others => '0');
    Autostitch_APB3mmaster_PWDATA(31 downto 16) <= (others => '0');
    Autostitch_APBmslave6_PRDATA(31 downto 8) <= (others => '0');

    --
    -- Component instances
    --

    -- Core8051s_00
    Core8051s_00 : CORE8051S
        -- Configuration generics
        generic map(
            APB_DWIDTH => 16,
            EN_FF_OPTS => 0,
            FAMILY => 17,
            INCL_DPTR1 => 0,
            INCL_MUL_DIV_DA => 0,
            INCL_TRACE => 0,
            STRETCH_VAL => 0,
            TRIG_NUM => 4,
            USE_OCI => 0,
            USE_UJTAG => 1,
            VARIABLE_STRETCH => 0,
            VARIABLE_WAIT => 1,
            WAIT_VAL => 0
        )
        -- Port map
        port map(
            -- Inputs
            BREAKIN => '0',
            CLK => SYSCLK,
            INT0 => '0',
            INT1 => '0',
            MEMACKI => ExternalMemIf_MEMACKI,
            MEMBANK => (others => '0'),
            MEMDATAI => ExternalMemIf_MEMDATAI,
            MEMPSACKI => ExternalMemIf_MEMPSACKI,
            NSYSRESET => NSYSRESET,
            PRDATA => Autostitch_APB3mmaster_PRDATA(15 downto 0),
            PREADY => Autostitch_APB3mmaster_PREADY,
            PSLVERR => Autostitch_APB3mmaster_PSLVERR,
            TCK => '1',
            TDI => '0',
            TMS => '0',
            TRSTN => '1',
            WDOGRES => '0',
            -- Outputs
            AUXOUT => open,
            BREAKOUT => open,
            DBGMEMPSWR => open,
            MEMADDR => ExternalMemIf_MEMADDR,
            MEMDATAO => ExternalMemIf_MEMDATAO,
            MEMPSRD => ExternalMemIf_MEMPSRD,
            MEMRD => ExternalMemIf_MEMRD,
            MEMWR => ExternalMemIf_MEMWR,
            MOVX => open,
            PADDR => Autostitch_APB3mmaster_PADDR(11 downto 0),
            PENABLE => Autostitch_APB3mmaster_PENABLE,
            PRESETN => iRESETN,
            PSEL => Autostitch_APB3mmaster_PSEL,
            PWDATA => Autostitch_APB3mmaster_PWDATA(15 downto 0),
            PWRITE => Autostitch_APB3mmaster_PWRITE,
            TDO => open,
            TRIGOUT => open,
            WDOGRESN => open
        );

    -- CoreAPB3_00
    CoreAPB3_00 : CoreAPB3
        -- Configuration generics
        generic map(
            ApbSlot0Enable => 0,
            ApbSlot10Enable => 0,
            ApbSlot11Enable => 0,
            ApbSlot12Enable => 0,
            ApbSlot13Enable => 0,
            ApbSlot14Enable => 0,
            ApbSlot15Enable => 0,
            ApbSlot1Enable => 0,
            ApbSlot2Enable => 0,
            ApbSlot3Enable => 0,
            ApbSlot4Enable => 1,
            ApbSlot5Enable => 0,
            ApbSlot6Enable => 1,
            ApbSlot7Enable => 0,
            ApbSlot8Enable => 0,
            ApbSlot9Enable => 0,
            RangeSize => 256
        )
        -- Port map
        port map(
            -- Inputs
            PADDR => Autostitch_APB3mmaster_PADDR,
            PENABLE => Autostitch_APB3mmaster_PENABLE,
            PRDATAS0 => (others => '0'),
            PRDATAS1 => (others => '0'),
            PRDATAS10 => (others => '0'),
            PRDATAS11 => (others => '0'),
            PRDATAS12 => (others => '0'),
            PRDATAS13 => (others => '0'),
            PRDATAS14 => (others => '0'),
            PRDATAS15 => (others => '0'),
            PRDATAS2 => (others => '0'),
            PRDATAS3 => (others => '0'),
            PRDATAS4 => Autostitch_APBmslave4_PRDATA,
            PRDATAS5 => (others => '0'),
            PRDATAS6 => Autostitch_APBmslave6_PRDATA,
            PRDATAS7 => (others => '0'),
            PRDATAS8 => (others => '0'),
            PRDATAS9 => (others => '0'),
            PREADYS0 => '1',
            PREADYS1 => '1',
            PREADYS10 => '1',
            PREADYS11 => '1',
            PREADYS12 => '1',
            PREADYS13 => '1',
            PREADYS14 => '1',
            PREADYS15 => '1',
            PREADYS2 => '1',
            PREADYS3 => '1',
            PREADYS4 => '1',
            PREADYS5 => '1',
            PREADYS6 => '1',
            PREADYS7 => '1',
            PREADYS8 => '1',
            PREADYS9 => '1',
            PSEL => Autostitch_APB3mmaster_PSEL,
            PSLVERRS0 => '0',
            PSLVERRS1 => '0',
            PSLVERRS10 => '0',
            PSLVERRS11 => '0',
            PSLVERRS12 => '0',
            PSLVERRS13 => '0',
            PSLVERRS14 => '0',
            PSLVERRS15 => '0',
            PSLVERRS2 => '0',
            PSLVERRS3 => '0',
            PSLVERRS4 => '0',
            PSLVERRS5 => '0',
            PSLVERRS6 => '0',
            PSLVERRS7 => '0',
            PSLVERRS8 => '0',
            PSLVERRS9 => '0',
            PWDATA => Autostitch_APB3mmaster_PWDATA,
            PWRITE => Autostitch_APB3mmaster_PWRITE,
            -- Outputs
            PADDRS => CoreAPB3_00_PADDRS,
            PENABLES => CoreAPB3_00_PENABLES,
            PRDATA => Autostitch_APB3mmaster_PRDATA,
            PREADY => Autostitch_APB3mmaster_PREADY,
            PSELS0 => open,
            PSELS1 => open,
            PSELS10 => open,
            PSELS11 => open,
            PSELS12 => open,
            PSELS13 => open,
            PSELS14 => open,
            PSELS15 => open,
            PSELS2 => open,
            PSELS3 => open,
            PSELS4 => Autostitch_APBmslave4_PSELx,
            PSELS5 => open,
            PSELS6 => Autostitch_APBmslave6_PSELx,
            PSELS7 => open,
            PSELS8 => open,
            PSELS9 => open,
            PSLVERR => Autostitch_APB3mmaster_PSLVERR,
            PWDATAS => CoreAPB3_00_PWDATAS,
            PWRITES => CoreAPB3_00_PWRITES
        );

    -- CoreGPIO_00
    CoreGPIO_00 : CoreGPIO
        -- Configuration generics
        generic map(
            NUM_INPUTS => 16,
            NUM_OUTPUTS => 16
        )
        -- Port map
        port map(
            -- Inputs
            PADDR => CoreAPB3_00_PADDRS(5 downto 2),
            PCLK => SYSCLK,
            PENABLE => CoreAPB3_00_PENABLES,
            PRESETn => iRESETN,
            PSEL => Autostitch_APBmslave4_PSELx,
            PWDATA => CoreAPB3_00_PWDATAS,
            PWRITE => CoreAPB3_00_PWRITES,
            dataIn => GP_IN,
            -- Outputs
            PRDATA => Autostitch_APBmslave4_PRDATA,
            dataOut => GP_OUT
        );

    -- CoreUARTapb_00
    CoreUARTapb_00 : CoreUARTapb
        -- Configuration generics
        generic map(
            ASYNCHRONOUS => 1,
            RX_FIFO => 0,
            TX_FIFO => 0
        )
        -- Port map
        port map(
            -- Inputs
            PADDR => CoreAPB3_00_PADDRS(4 downto 2),
            PCLK => SYSCLK,
            PENABLE => CoreAPB3_00_PENABLES,
            PRESETn => iRESETN,
            PSEL => Autostitch_APBmslave6_PSELx,
            PWDATA => CoreAPB3_00_PWDATAS(7 downto 0),
            PWRITE => CoreAPB3_00_PWRITES,
            rx => RX,
            -- Outputs
            PRDATA => Autostitch_APBmslave6_PRDATA(7 downto 0),
            receive_full => open,
            tx => TX,
            txrdy => open
        );

end RTL;

