//////////////////////////////////////////////////////////////////////
// Created by Actel CoreConsole - Mon Mar 24 12:15:12 2008
//////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module testbench;

parameter SYSCLK_PERIOD = 100; // 10MHz

reg SYSCLK;
reg NSYSRESET;

initial
begin
    SYSCLK = 1'b0;
    NSYSRESET = 1'b0;

    // Release system reset
    #(SYSCLK_PERIOD * 4)
        NSYSRESET = 1'b1;

    #(SYSCLK_PERIOD * 100000);

    $stop;
end

// SYSCLK signal
always @(SYSCLK)
    #(SYSCLK_PERIOD / 2)
    SYSCLK <= !SYSCLK;

// Instantiate module to test
ProcessorSystem ProcessorSystem_0(
    // Inputs
    .ExternalMemIf_MEMACKI({1{1'b1}}),
    .ExternalMemIf_MEMDATAI({8{1'b0}}),
    .ExternalMemIf_MEMPSACKI({1{1'b1}}),
    .GP_IN({16{1'b0}}),
    .NSYSRESET(NSYSRESET),
    .RX({1{1'b0}}),
    .SYSCLK(SYSCLK),
    // Outputs
    .ExternalMemIf_MEMADDR(),
    .ExternalMemIf_MEMDATAO(),
    .ExternalMemIf_MEMPSRD(),
    .ExternalMemIf_MEMRD(),
    .ExternalMemIf_MEMWR(),
    .GP_OUT(),
    .RESETN(),
    .TX()
);

endmodule

