----------------------------------------------------------------------
-- Created by Actel CoreConsole - Mon Mar 24 12:15:12 2008
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end testbench;

architecture behavioral of testbench is

    constant SYSCLK_PERIOD : time := 100 ns;

    -- Component to test
    component ProcessorSystem
        -- Port list
        port(
            -- Inputs
            ExternalMemIf_MEMACKI : in std_logic;
            ExternalMemIf_MEMDATAI : in std_logic_vector(7 downto 0);
            ExternalMemIf_MEMPSACKI : in std_logic;
            GP_IN : in std_logic_vector(15 downto 0);
            NSYSRESET : in std_logic;
            RX : in std_logic;
            SYSCLK : in std_logic;
            -- Outputs
            ExternalMemIf_MEMADDR : out std_logic_vector(15 downto 0);
            ExternalMemIf_MEMDATAO : out std_logic_vector(7 downto 0);
            ExternalMemIf_MEMPSRD : out std_logic;
            ExternalMemIf_MEMRD : out std_logic;
            ExternalMemIf_MEMWR : out std_logic;
            GP_OUT : out std_logic_vector(15 downto 0);
            RESETN : out std_logic;
            TX : out std_logic
        );
    end component;

    signal SYSCLK    : std_logic := '0';
    signal NSYSRESET : std_logic;

begin

    process
        variable vhdl_initial : BOOLEAN := TRUE; 

    begin
        if (vhdl_initial) then
            -- Assert system reset
            NSYSRESET <= '0';
            wait for (SYSCLK_PERIOD * 4);

            -- Release system reset
            NSYSRESET <= '1';
            wait;
        else
            wait;
        end if; 
    end process;

    -- SYSCLK signal
    SYSCLK <= not SYSCLK after (SYSCLK_PERIOD / 2);

    -- Instantiate module to test

    ProcessorSystem_0 : ProcessorSystem
        -- Port map
        port map(
            -- Inputs
            ExternalMemIf_MEMACKI => '1',
            ExternalMemIf_MEMDATAI => (others => '0'),
            ExternalMemIf_MEMPSACKI => '1',
            GP_IN => (others => '0'),
            NSYSRESET => NSYSRESET,
            RX => '0',
            SYSCLK => SYSCLK,
            -- Outputs
            ExternalMemIf_MEMADDR => open,
            ExternalMemIf_MEMDATAO => open,
            ExternalMemIf_MEMPSRD => open,
            ExternalMemIf_MEMRD => open,
            ExternalMemIf_MEMWR => open,
            GP_OUT => open,
            RESETN => open,
            TX => open
        );

end behavioral;
