`timescale 1ns/1ns
module
CoreUARTapb
(
PCLK
,
PRESETn
,
PADDR
,
PSEL
,
PENABLE
,
PWRITE
,
PWDATA
,
PRDATA
,
txrdy
,
receive_full
,
rx
,
tx
)
;
parameter
TX_FIFO
=
0
;
parameter
RX_FIFO
=
0
;
parameter
ASYNCHRONOUS
=
1
;
input
PCLK
;
input
PRESETn
;
input
[
4
:
2
]
PADDR
;
input
PSEL
;
input
PENABLE
;
input
PWRITE
;
input
[
7
:
0
]
PWDATA
;
output
[
7
:
0
]
PRDATA
;
output
txrdy
;
output
receive_full
;
input
rx
;
output
tx
;
`define CoreUARTapb_IOI  \
3 \
'b \
000
`define CoreUARTapb_lOI  \
3 \
'b \
001
`define CoreUARTapb_OII  \
3 \
'b \
010
`define CoreUARTapb_III  \
3 \
'b \
011
`define CoreUARTapb_lII  \
3 \
'b \
100
wire
PCLK
;
wire
PRESETn
;
wire
[
4
:
2
]
PADDR
;
wire
PSEL
;
wire
PENABLE
;
wire
PWRITE
;
wire
[
7
:
0
]
PWDATA
;
wire
[
7
:
0
]
PRDATA
;
wire
txrdy
;
wire
receive_full
;
wire
rx
;
wire
tx
;
reg
[
7
:
0
]
CoreUARTapb_OlI
;
reg
[
2
:
0
]
CoreUARTapb_IlI
;
reg
[
7
:
0
]
CoreUARTapb_llI
;
reg
[
7
:
0
]
CoreUARTapb_O0I
;
wire
CoreUARTapb_I0I
;
wire
[
7
:
0
]
CoreUARTapb_l0I
;
wire
[
7
:
0
]
CoreUARTapb_O1I
;
wire
[
7
:
0
]
CoreUARTapb_Il
;
wire
CoreUARTapb_I1I
;
wire
CoreUARTapb_l1I
;
wire
CoreUARTapb_OOl
;
wire
CoreUARTapb_IOl
;
wire
CoreUARTapb_lOl
;
wire
CoreUARTapb_OIl
;
wire
CoreUARTapb_IIl
;
wire
CoreUARTapb_lIl
;
assign
CoreUARTapb_IOl
=
!
(
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CoreUARTapb_IOI
)
)
;
assign
CoreUARTapb_lOl
=
!
(
PENABLE
&&
!
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CoreUARTapb_lOI
)
)
;
assign
CoreUARTapb_OIl
=
!
PSEL
;
assign
CoreUARTapb_l0I
=
PWDATA
;
assign
CoreUARTapb_I0I
=
(
PSEL
&
!
PWRITE
&
!
PENABLE
)
;
always
@
(
PADDR
or
CoreUARTapb_I0I
or
CoreUARTapb_O0I
or
CoreUARTapb_O1I
or
CoreUARTapb_OlI
or
CoreUARTapb_IlI
or
CoreUARTapb_IIl
or
CoreUARTapb_lIl
or
receive_full
or
txrdy
)
begin
:
CoreUARTapb_Oll
if
(
CoreUARTapb_I0I
)
case
(
PADDR
[
4
:
2
]
)
`CoreUARTapb_IOI
:
CoreUARTapb_llI
=
8
'b
0
;
`CoreUARTapb_lOI
:
CoreUARTapb_llI
=
CoreUARTapb_O1I
;
`CoreUARTapb_OII
:
CoreUARTapb_llI
=
CoreUARTapb_OlI
;
`CoreUARTapb_III
:
CoreUARTapb_llI
=
{
5
'b
0
,
CoreUARTapb_IlI
}
;
`CoreUARTapb_lII
:
CoreUARTapb_llI
=
{
4
'b
0
,
CoreUARTapb_IIl
,
CoreUARTapb_lIl
,
receive_full
,
txrdy
}
;
default
:
CoreUARTapb_llI
=
CoreUARTapb_O0I
;
endcase
else
CoreUARTapb_llI
=
CoreUARTapb_O0I
;
end
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
:
CoreUARTapb_Ill
if
(
!
PRESETn
)
CoreUARTapb_O0I
<=
8
'b
0
;
else
CoreUARTapb_O0I
<=
CoreUARTapb_llI
;
end
assign
PRDATA
=
CoreUARTapb_O0I
;
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
:
CoreUARTapb_lll
if
(
!
PRESETn
)
CoreUARTapb_OlI
<=
8
'b
0
;
else
if
(
PSEL
&&
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CoreUARTapb_OII
)
)
CoreUARTapb_OlI
<=
PWDATA
;
else
CoreUARTapb_OlI
<=
CoreUARTapb_OlI
;
end
assign
CoreUARTapb_Il
=
CoreUARTapb_OlI
;
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
:
CoreUARTapb_O0l
if
(
!
PRESETn
)
CoreUARTapb_IlI
<=
3
'b
0
;
else
if
(
PSEL
&&
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CoreUARTapb_III
)
)
CoreUARTapb_IlI
<=
PWDATA
[
2
:
0
]
;
else
CoreUARTapb_IlI
<=
CoreUARTapb_IlI
;
end
assign
CoreUARTapb_I1I
=
CoreUARTapb_IlI
[
0
]
;
assign
CoreUARTapb_l1I
=
CoreUARTapb_IlI
[
1
]
;
assign
CoreUARTapb_OOl
=
CoreUARTapb_IlI
[
2
]
;
CoreUARTapb_I0l
#
(
.TX_FIFO
(
TX_FIFO
)
,
.RX_FIFO
(
RX_FIFO
)
,
.ASYNCHRONOUS
(
ASYNCHRONOUS
)
)
CoreUARTapb_l0l
(
.CoreUARTapb_Ol
(
PRESETn
)
,
.CoreUARTapb_lI
(
PCLK
)
,
.CoreUARTapb_IOl
(
CoreUARTapb_IOl
)
,
.CoreUARTapb_lOl
(
CoreUARTapb_lOl
)
,
.CoreUARTapb_OIl
(
CoreUARTapb_OIl
)
,
.CoreUARTapb_l0I
(
CoreUARTapb_l0I
)
,
.rx
(
rx
)
,
.CoreUARTapb_Il
(
CoreUARTapb_Il
)
,
.CoreUARTapb_I1I
(
CoreUARTapb_I1I
)
,
.CoreUARTapb_l1I
(
CoreUARTapb_l1I
)
,
.CoreUARTapb_OOl
(
CoreUARTapb_OOl
)
,
.CoreUARTapb_lIl
(
CoreUARTapb_lIl
)
,
.CoreUARTapb_IIl
(
CoreUARTapb_IIl
)
,
.txrdy
(
txrdy
)
,
.receive_full
(
receive_full
)
,
.CoreUARTapb_O1I
(
CoreUARTapb_O1I
)
,
.tx
(
tx
)
)
;
endmodule
