// *****************************************************************
//                  Low Ripple DAC
// *****************************************************************

// Written by   Stephane Gauthier
//              Actel Corporation
//              December 15, 2006

// This core expects a 12 bit DAC value, and creates a pulse stream
// output that has been optmized for extremely low ripple.
//
//IMPORTANT-READ THESE TERMS CAREFULLY BEFORE UTILIZING THE INFORMATION CONTAINED IN THIS APPLICATION NOTE. 
//
//NO SUPPORT/NO WARRANTY.  
//THE DESIGN FILES AND DOCUMENTATION ARE PROVIDED WITHOUT SUPPORT OR WARRANTY OF ANY KIND.  
//ACTEL IS NOT OBLIGATED TO PROVIDE UPDATES, BUG FIXES, OR TECHNICAL SUPPORT AND DISCLAIMS ALL WARRANTIES INCLUDING, 
//WITHOUT LIMITATION, THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND WARRANTIES OF 
//NON-INFRINGEMENT OF THE RIGHTS OF THIRD PARTIES (INCLUDING, WITHOUT LIMITATION, RIGHTS UNDER PATENT, COPYRIGHT, 
//TRADE SECRET, OR OTHER INTELLECTUAL PROPERTY RIGHTS).  RECIPIENT ACCEPTS THE APPLICATION NOTE DESIGN FILES AND 
//DOCUMENTATION IN "AS-IS" CONDITION.


module LowRippleDAC (
  clk,
  rstn,
  DACin,
  DACout
)
;
input clk ;
input rstn ;
input [11:0] DACin ;
output DACout ;
wire clk ;
wire rstn ;
wire DACout ;
wire [11:0] acc;
wire [10:4] acc_i_0;
wire GND ;
wire ADD_12x12_medium_area_I0_S ;
wire ADD_12x12_medium_area_I55_Y ;
wire ADD_12x12_medium_area_I56_Y ;
wire ADD_12x12_medium_area_I57_Y ;
wire ADD_12x12_medium_area_I58_Y ;
wire ADD_12x12_medium_area_I59_Y ;
wire ADD_12x12_medium_area_I60_Y ;
wire ADD_12x12_medium_area_I61_Y ;
wire ADD_12x12_medium_area_I62_Y ;
wire ADD_12x12_medium_area_I63_Y ;
wire ADD_12x12_medium_area_I64_Y ;
wire ADD_12x12_medium_area_I65_Y ;
wire ADD_12x12_medium_area_I35_Y ;
wire VCC ;
wire \un5_acc.N232  ;
wire \un5_acc.N222  ;
wire \un5_acc.N238  ;
wire \un5_acc.N224  ;
wire \un5_acc.N236  ;
wire \un5_acc.N180  ;
wire \un5_acc.N176  ;
wire \un5_acc.N177  ;
wire \un5_acc.N181  ;
wire \un5_acc.N218  ;
wire \un5_acc.N219  ;
wire \un5_acc.N187  ;
wire \un5_acc.N234  ;
wire \un5_acc.N174  ;
wire \un5_acc.N170  ;
wire \un5_acc.N169  ;
wire \un5_acc.N173  ;
wire \un5_acc.N228  ;
wire \un5_acc.N229  ;
wire \un5_acc.N191  ;
wire \un5_acc.N161  ;
wire \un5_acc.N196  ;
wire \un5_acc.N166  ;
wire \un5_acc.N165  ;
wire ADD_12x12_medium_area_I53_un1_Y ;
wire ADD_12x12_medium_area_I52_un1_Y ;
wire ADD_12x12_medium_area_I54_un1_Y ;
wire \un5_acc.ADD_12x12_medium_area_I27_un1_Y_0  ;
wire \un5_acc.ADD_12x12_medium_area_I27_Y_0  ;
wire \un5_acc.ADD_12x12_medium_area_I28_un1_Y_0  ;
wire \un5_acc.ADD_12x12_medium_area_I28_Y_0  ;
wire \un5_acc.ADD_12x12_medium_area_I28_Y_1  ;
wire \un5_acc.ADD_12x12_medium_area_I35_un1_Y_0  ;
wire \un5_acc.ADD_12x12_medium_area_I35_Y_0  ;
wire \un5_acc.ADD_12x12_medium_area_I35_Y_1  ;
wire GND_Z ;
wire VCC_Z ;
  AOI1B \un5_acc.ADD_12x12_medium_area_I35_Y_1_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I35_Y_1 ),
	.A(\un5_acc.N187 ),
	.B(\un5_acc.N218 ),
	.C(\un5_acc.ADD_12x12_medium_area_I35_Y_0 )
);
  MIN3 \un5_acc.ADD_12x12_medium_area_I35_Y_0_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I35_Y_0 ),
	.A(DACin[11]),
	.B(acc[11]),
	.C(\un5_acc.N181 )
);
  NOR2B \un5_acc.ADD_12x12_medium_area_I35_un1_Y_0_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I35_un1_Y_0 ),
	.A(\un5_acc.N187 ),
	.B(\un5_acc.N219 )
);
  AOI1B \un5_acc.ADD_12x12_medium_area_I28_Y_1_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I28_Y_1 ),
	.A(\un5_acc.N191 ),
	.B(\un5_acc.N228 ),
	.C(\un5_acc.ADD_12x12_medium_area_I28_Y_0 )
);
  MIN3 \un5_acc.ADD_12x12_medium_area_I28_Y_0_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I28_Y_0 ),
	.A(DACin[7]),
	.B(acc[7]),
	.C(\un5_acc.N173 )
);
  NOR2B \un5_acc.ADD_12x12_medium_area_I28_un1_Y_0_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I28_un1_Y_0 ),
	.A(\un5_acc.N191 ),
	.B(\un5_acc.N229 )
);
  MIN3 \un5_acc.ADD_12x12_medium_area_I27_Y_0_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I27_Y_0 ),
	.A(DACin[3]),
	.B(acc[3]),
	.C(\un5_acc.N165 )
);
  XA1 \un5_acc.ADD_12x12_medium_area_I27_un1_Y_0_cZ  (
	.Y(\un5_acc.ADD_12x12_medium_area_I27_un1_Y_0 ),
	.A(DACin[2]),
	.B(acc[2]),
	.C(\un5_acc.N166 )
);
  AO1B \un5_acc.ADD_12x12_medium_area_I27_Y  (
	.Y(\un5_acc.N232 ),
	.A(\un5_acc.N196 ),
	.B(\un5_acc.ADD_12x12_medium_area_I27_un1_Y_0 ),
	.C(\un5_acc.ADD_12x12_medium_area_I27_Y_0 )
);
  AO1B \un5_acc.ADD_12x12_medium_area_I28_Y  (
	.Y(\un5_acc.N222 ),
	.A(\un5_acc.N232 ),
	.B(\un5_acc.ADD_12x12_medium_area_I28_un1_Y_0 ),
	.C(\un5_acc.ADD_12x12_medium_area_I28_Y_1 )
);
  AO1B \un5_acc.ADD_12x12_medium_area_I35_Y  (
	.Y(ADD_12x12_medium_area_I35_Y),
	.A(\un5_acc.N222 ),
	.B(\un5_acc.ADD_12x12_medium_area_I35_un1_Y_0 ),
	.C(\un5_acc.ADD_12x12_medium_area_I35_Y_1 )
);
  NOR2B \un5_acc.ADD_12x12_medium_area_I0_CO1  (
	.Y(\un5_acc.N161 ),
	.A(acc[0]),
	.B(DACin[0])
);
  NOR2B \un5_acc.ADD_12x12_medium_area_I2_CO1  (
	.Y(\un5_acc.N165 ),
	.A(acc[2]),
	.B(DACin[2])
);
  MAJ3 \un5_acc.ADD_12x12_medium_area_I22_Y  (
	.Y(\un5_acc.N196 ),
	.A(DACin[1]),
	.B(acc[1]),
	.C(\un5_acc.N161 )
);
  XA1 \un5_acc.ADD_12x12_medium_area_I54_un1_Y  (
	.Y(ADD_12x12_medium_area_I54_un1_Y),
	.A(DACin[2]),
	.B(acc[2]),
	.C(\un5_acc.N196 )
);
  XOR2 \un5_acc.ADD_12x12_medium_area_I0_S  (
	.Y(ADD_12x12_medium_area_I0_S),
	.A(acc[0]),
	.B(DACin[0])
);
  XOR2 \un5_acc.ADD_12x12_medium_area_I3_S  (
	.Y(\un5_acc.N166 ),
	.A(acc[3]),
	.B(DACin[3])
);
  AX1D \un5_acc.ADD_12x12_medium_area_I57_Y  (
	.Y(ADD_12x12_medium_area_I57_Y),
	.A(ADD_12x12_medium_area_I54_un1_Y),
	.B(\un5_acc.N165 ),
	.C(\un5_acc.N166 )
);
  XOR3 \un5_acc.ADD_12x12_medium_area_I56_Y  (
	.Y(ADD_12x12_medium_area_I56_Y),
	.A(DACin[2]),
	.B(acc[2]),
	.C(\un5_acc.N196 )
);
  XOR3 \un5_acc.ADD_12x12_medium_area_I55_Y  (
	.Y(ADD_12x12_medium_area_I55_Y),
	.A(DACin[1]),
	.B(acc[1]),
	.C(\un5_acc.N161 )
);
  NOR2A \un5_acc.ADD_12x12_medium_area_I4_CO1  (
	.Y(\un5_acc.N169 ),
	.A(DACin[4]),
	.B(acc_i_0[4])
);
  NOR2A \un5_acc.ADD_12x12_medium_area_I6_CO1  (
	.Y(\un5_acc.N173 ),
	.A(DACin[6]),
	.B(acc_i_0[6])
);
  XA1A \un5_acc.ADD_12x12_medium_area_I17_Y  (
	.Y(\un5_acc.N191 ),
	.A(DACin[6]),
	.B(acc_i_0[6]),
	.C(\un5_acc.N174 )
);
  MAJ3 \un5_acc.ADD_12x12_medium_area_I18_Y  (
	.Y(\un5_acc.N228 ),
	.A(DACin[5]),
	.B(acc[5]),
	.C(\un5_acc.N169 )
);
  XA1A \un5_acc.ADD_12x12_medium_area_I19_Y  (
	.Y(\un5_acc.N229 ),
	.A(DACin[4]),
	.B(acc_i_0[4]),
	.C(\un5_acc.N170 )
);
  AO1 \un5_acc.ADD_12x12_medium_area_I49_Y  (
	.Y(\un5_acc.N234 ),
	.A(\un5_acc.N229 ),
	.B(\un5_acc.N232 ),
	.C(\un5_acc.N228 )
);
  XA1A \un5_acc.ADD_12x12_medium_area_I52_un1_Y  (
	.Y(ADD_12x12_medium_area_I52_un1_Y),
	.A(DACin[6]),
	.B(acc_i_0[6]),
	.C(\un5_acc.N234 )
);
  XA1A \un5_acc.ADD_12x12_medium_area_I53_un1_Y  (
	.Y(ADD_12x12_medium_area_I53_un1_Y),
	.A(DACin[4]),
	.B(acc_i_0[4]),
	.C(\un5_acc.N232 )
);
  XOR2 \un5_acc.ADD_12x12_medium_area_I5_S  (
	.Y(\un5_acc.N170 ),
	.A(acc[5]),
	.B(DACin[5])
);
  XOR2 \un5_acc.ADD_12x12_medium_area_I7_S  (
	.Y(\un5_acc.N174 ),
	.A(acc[7]),
	.B(DACin[7])
);
  AX1D \un5_acc.ADD_12x12_medium_area_I61_Y  (
	.Y(ADD_12x12_medium_area_I61_Y),
	.A(ADD_12x12_medium_area_I52_un1_Y),
	.B(\un5_acc.N173 ),
	.C(\un5_acc.N174 )
);
  XOR3 \un5_acc.ADD_12x12_medium_area_I60_Y  (
	.Y(ADD_12x12_medium_area_I60_Y),
	.A(DACin[6]),
	.B(acc_i_0[6]),
	.C(\un5_acc.N234 )
);
  AX1D \un5_acc.ADD_12x12_medium_area_I59_Y  (
	.Y(ADD_12x12_medium_area_I59_Y),
	.A(ADD_12x12_medium_area_I53_un1_Y),
	.B(\un5_acc.N169 ),
	.C(\un5_acc.N170 )
);
  XOR3 \un5_acc.ADD_12x12_medium_area_I58_Y  (
	.Y(ADD_12x12_medium_area_I58_Y),
	.A(DACin[4]),
	.B(acc_i_0[4]),
	.C(\un5_acc.N232 )
);
  NOR2A \un5_acc.ADD_12x12_medium_area_I8_CO1  (
	.Y(\un5_acc.N177 ),
	.A(DACin[8]),
	.B(acc_i_0[8])
);
  NOR2A \un5_acc.ADD_12x12_medium_area_I10_CO1  (
	.Y(\un5_acc.N181 ),
	.A(DACin[10]),
	.B(acc_i_0[10])
);
  XA1 \un5_acc.ADD_12x12_medium_area_I13_Y  (
	.Y(\un5_acc.N187 ),
	.A(DACin[11]),
	.B(acc[11]),
	.C(\un5_acc.N180 )
);
  MAJ3 \un5_acc.ADD_12x12_medium_area_I14_Y  (
	.Y(\un5_acc.N218 ),
	.A(DACin[9]),
	.B(acc[9]),
	.C(\un5_acc.N177 )
);
  XA1 \un5_acc.ADD_12x12_medium_area_I15_Y  (
	.Y(\un5_acc.N219 ),
	.A(DACin[9]),
	.B(acc[9]),
	.C(\un5_acc.N176 )
);
  AO1 \un5_acc.ADD_12x12_medium_area_I42_Y  (
	.Y(\un5_acc.N224 ),
	.A(\un5_acc.N219 ),
	.B(\un5_acc.N222 ),
	.C(\un5_acc.N218 )
);
  AO13 \un5_acc.ADD_12x12_medium_area_I50_Y  (
	.Y(\un5_acc.N236 ),
	.A(DACin[10]),
	.B(\un5_acc.N224 ),
	.C(acc_i_0[10])
);
  AO13 \un5_acc.ADD_12x12_medium_area_I51_Y  (
	.Y(\un5_acc.N238 ),
	.A(DACin[8]),
	.B(\un5_acc.N222 ),
	.C(acc_i_0[8])
);
  XNOR2 \un5_acc.ADD_12x12_medium_area_I8_S  (
	.Y(\un5_acc.N176 ),
	.A(acc_i_0[8]),
	.B(DACin[8])
);
  XNOR2 \un5_acc.ADD_12x12_medium_area_I10_S  (
	.Y(\un5_acc.N180 ),
	.A(acc_i_0[10]),
	.B(DACin[10])
);
  XOR3 \un5_acc.ADD_12x12_medium_area_I65_Y  (
	.Y(ADD_12x12_medium_area_I65_Y),
	.A(DACin[11]),
	.B(acc[11]),
	.C(\un5_acc.N236 )
);
  XNOR2 \un5_acc.ADD_12x12_medium_area_I64_Y  (
	.Y(ADD_12x12_medium_area_I64_Y),
	.A(\un5_acc.N224 ),
	.B(\un5_acc.N180 )
);
  XOR3 \un5_acc.ADD_12x12_medium_area_I63_Y  (
	.Y(ADD_12x12_medium_area_I63_Y),
	.A(DACin[9]),
	.B(acc[9]),
	.C(\un5_acc.N238 )
);
  XNOR2 \un5_acc.ADD_12x12_medium_area_I62_Y  (
	.Y(ADD_12x12_medium_area_I62_Y),
	.A(\un5_acc.N222 ),
	.B(\un5_acc.N176 )
);
// @2:61
  DFN1C0 \acc_Z[0]  (
	.Q(acc[0]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I0_S)
);
// @2:61
  DFN1C0 \acc_Z[1]  (
	.Q(acc[1]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I55_Y)
);
// @2:61
  DFN1C0 \acc_Z[2]  (
	.Q(acc[2]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I56_Y)
);
// @2:61
  DFN1C0 \acc_Z[3]  (
	.Q(acc[3]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I57_Y)
);
// @2:61
  DFN1P0 \acc_Z[4]  (
	.Q(acc_i_0[4]),
	.CLK(clk),
	.D(ADD_12x12_medium_area_I58_Y),
	.PRE(rstn)
);
// @2:61
  DFN1C0 \acc_Z[5]  (
	.Q(acc[5]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I59_Y)
);
// @2:61
  DFN1P0 \acc_Z[6]  (
	.Q(acc_i_0[6]),
	.CLK(clk),
	.D(ADD_12x12_medium_area_I60_Y),
	.PRE(rstn)
);
// @2:61
  DFN1C0 \acc_Z[7]  (
	.Q(acc[7]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I61_Y)
);
// @2:61
  DFN1P0 \acc_Z[8]  (
	.Q(acc_i_0[8]),
	.CLK(clk),
	.D(ADD_12x12_medium_area_I62_Y),
	.PRE(rstn)
);
// @2:61
  DFN1C0 \acc_Z[9]  (
	.Q(acc[9]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I63_Y)
);
// @2:61
  DFN1P0 \acc_Z[10]  (
	.Q(acc_i_0[10]),
	.CLK(clk),
	.D(ADD_12x12_medium_area_I64_Y),
	.PRE(rstn)
);
// @2:61
  DFN1C0 \acc_Z[11]  (
	.Q(acc[11]),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I65_Y)
);
// @2:61
  DFN1C0 \acc_Z[12]  (
	.Q(DACout),
	.CLK(clk),
	.CLR(rstn),
	.D(ADD_12x12_medium_area_I35_Y)
);
  VCC VCC_i (
	.Y(VCC)
);
  GND GND_i (
	.Y(GND)
);
  assign GND_Z = 1'b0;
  assign VCC_Z = 1'b1;
endmodule /* LowRippleDAC */

