library verilog;
use verilog.vl_types.all;
entity CORE8051S is
    generic(
        USE_OCI         : integer := 0;
        USE_UJTAG       : integer := 1;
        INCL_TRACE      : integer := 0;
        TRIG_NUM        : integer := 0;
        EN_FF_OPTS      : integer := 0;
        APB_DWIDTH      : integer := 32;
        INCL_DPTR1      : integer := 0;
        INCL_MUL_DIV_DA : integer := 1;
        VARIABLE_STRETCH: integer := 1;
        STRETCH_VAL     : integer := 1;
        VARIABLE_WAIT   : integer := 1;
        WAIT_VAL        : integer := 0;
        FAMILY          : integer := 0
    );
    port(
        CLK             : in     vl_logic;
        NSYSRESET       : in     vl_logic;
        PRESETN         : out    vl_logic;
        WDOGRES         : in     vl_logic;
        WDOGRESN        : out    vl_logic;
        INT0            : in     vl_logic;
        INT1            : in     vl_logic;
        MOVX            : out    vl_logic;
        MEMPSACKI       : in     vl_logic;
        MEMACKI         : in     vl_logic;
        MEMDATAI        : in     vl_logic_vector(7 downto 0);
        MEMDATAO        : out    vl_logic_vector(7 downto 0);
        MEMADDR         : out    vl_logic_vector(15 downto 0);
        MEMPSRD         : out    vl_logic;
        MEMWR           : out    vl_logic;
        MEMRD           : out    vl_logic;
        TCK             : in     vl_logic;
        TMS             : in     vl_logic;
        TDI             : in     vl_logic;
        TDO             : out    vl_logic;
        TRSTN           : in     vl_logic;
        BREAKIN         : in     vl_logic;
        BREAKOUT        : out    vl_logic;
        MEMBANK         : in     vl_logic_vector(3 downto 0);
        DBGMEMPSWR      : out    vl_logic;
        TRIGOUT         : out    vl_logic;
        AUXOUT          : out    vl_logic;
        PWRITE          : out    vl_logic;
        PENABLE         : out    vl_logic;
        PSEL            : out    vl_logic;
        PADDR           : out    vl_logic_vector(11 downto 0);
        PWDATA          : out    vl_logic_vector;
        PRDATA          : in     vl_logic_vector;
        PREADY          : in     vl_logic;
        PSLVERR         : in     vl_logic
    );
end CORE8051S;
