`timescale 1 ns/100 ps
// Version: 8.3 8.3.0.22


module AnalogSystem(
       SYS_CLK,
       SYS_RESET,
       VAREF,
       DATAVALID,
       VIN,
       ASSC_SEQIN,
       ASSC_XMODE,
       ASSC_XTRIG,
       ASSC_SEQJUMP,
       ASSC_DONE,
       ASSC_WAIT,
       ASSC_CHSAT,
       ASSC_CHLATD,
       ASSC_SEQCHANGE,
       ASSC_SEQOUT,
       ASSC_SAMPFLAG,
       INIT_ADDR,
       INIT_DATA,
       INIT_ACM_WEN,
       INIT_ASSC_WEN,
       INIT_CALIBROM_WEN,
       INIT_CALIBCOEFF_WEN,
       INIT_DONE,
       ADC_RESULT,
       ADC_CHNUMBER
    );
input  SYS_CLK;
input  SYS_RESET;
inout  VAREF;
output DATAVALID;
input  VIN;
input  [5:0] ASSC_SEQIN;
input  ASSC_XMODE;
input  ASSC_XTRIG;
input  ASSC_SEQJUMP;
output ASSC_DONE;
output ASSC_WAIT;
output ASSC_CHSAT;
output ASSC_CHLATD;
output ASSC_SEQCHANGE;
output [5:0] ASSC_SEQOUT;
output ASSC_SAMPFLAG;
input  [10:0] INIT_ADDR;
input  [8:0] INIT_DATA;
input  INIT_ACM_WEN;
input  INIT_ASSC_WEN;
input  INIT_CALIBROM_WEN;
input  INIT_CALIBCOEFF_WEN;
input  INIT_DONE;
output [11:0] ADC_RESULT;
output [4:0] ADC_CHNUMBER;

    wire GND_net, VCC_net, ASSC_RAM_RW_A_net, ASSC_RAM_CSN_A_net;
    wire [8:0] ASSC_RAM_DI_A_net;
    wire [8:0] ASSC_RAM_ADDR_A_net;
    wire ASSC_RAM_RW_B_net, ASSC_RAM_CSN_B_net;
    wire [8:0] ASSC_RAM_DI_B_net;
    wire [8:0] ASSC_RAM_ADDR_B_net;
    wire [8:0] ASSC_RAM_DO_B_net;
    wire ADC_START_net, ADC_PDOWN_net, ADC_RESET_net;
    wire [3:0] ADC_MODE_net;
    wire ADC_VREFSEL_net;
    wire [7:0] ADC_STC_net;
    wire [7:0] ADC_TVC_net;
    wire ADC_CALIBRATE_net, ADC_BUSY_CALIB_net, ADC_BUSY_net, 
        CM_STB_net_0, CM_STB_net_1, CM_STB_net_2, CM_STB_net_3, 
        CM_STB_net_4, CM_STB_net_5, CM_STB_net_6, CM_STB_net_7, 
        CM_STB_net_8, CM_STB_net_9, TM_STB_net_0, TM_STB_net_1, 
        TM_STB_net_2, TM_STB_net_3, TM_STB_net_4, TM_STB_net_5, 
        TM_STB_net_6, TM_STB_net_7, TM_STB_net_8, TM_STB_net_9, 
        TM_STB_net_10;
    wire [11:0] ADCRESULT_net;
    wire INIT_ACM_WEN_OR_net, DATAVALID_CALIB_net, AT5_net;
    wire GND_power_net1;
    wire VCC_power_net1;
    assign GND_net = GND_power_net1;
    assign VCC_net = VCC_power_net1;
    
    OR2 INIT_ACMWEN_OR (.A(INIT_ACM_WEN), .B(GND_net), .Y(
        INIT_ACM_WEN_OR_net));
    AB #( .ACT_DIE("M7IR6X6M2"), .ACT_PKG("fg484") )  AB_INST (
        .DAVOUT0(), .DACOUT0(), .DATOUT0(), .DAVOUT1(), .DACOUT1(), 
        .DATOUT1(), .DAVOUT2(), .DACOUT2(), .DATOUT2(), .DAVOUT3(), 
        .DACOUT3(), .DATOUT3(), .DAVOUT4(), .DACOUT4(), .DATOUT4(), 
        .DAVOUT5(), .DACOUT5(), .DATOUT5(), .DAVOUT6(), .DACOUT6(), 
        .DATOUT6(), .DAVOUT7(), .DACOUT7(), .DATOUT7(), .DAVOUT8(), 
        .DACOUT8(), .DATOUT8(), .DAVOUT9(), .DACOUT9(), .DATOUT9(), 
        .DENAV0(GND_net), .DENAC0(GND_net), .DENAT0(GND_net), .DENAV1(
        GND_net), .DENAC1(GND_net), .DENAT1(GND_net), .DENAV2(GND_net), 
        .DENAC2(GND_net), .DENAT2(GND_net), .DENAV3(GND_net), .DENAC3(
        GND_net), .DENAT3(GND_net), .DENAV4(GND_net), .DENAC4(GND_net), 
        .DENAT4(GND_net), .DENAV5(GND_net), .DENAC5(GND_net), .DENAT5(
        GND_net), .DENAV6(GND_net), .DENAC6(GND_net), .DENAT6(GND_net), 
        .DENAV7(GND_net), .DENAC7(GND_net), .DENAT7(GND_net), .DENAV8(
        GND_net), .DENAC8(GND_net), .DENAT8(GND_net), .DENAV9(GND_net), 
        .DENAC9(GND_net), .DENAT9(GND_net), .AV0(GND_net), .AC0(
        GND_net), .AT0(GND_net), .AG0(), .AV1(GND_net), .AC1(GND_net), 
        .AT1(GND_net), .AG1(), .AV2(GND_net), .AC2(GND_net), .AT2(
        GND_net), .AG2(), .AV3(GND_net), .AC3(GND_net), .AT3(GND_net), 
        .AG3(), .AV4(GND_net), .AC4(GND_net), .AT4(GND_net), .AG4(), 
        .AV5(GND_net), .AC5(GND_net), .AT5(AT5_net), .AG5(), .AV6(
        GND_net), .AC6(GND_net), .AT6(GND_net), .AG6(), .AV7(GND_net), 
        .AC7(GND_net), .AT7(GND_net), .AG7(), .AV8(GND_net), .AC8(
        GND_net), .AT8(GND_net), .AG8(), .AV9(GND_net), .AC9(GND_net), 
        .AT9(GND_net), .AG9(), .ATRETURN01(GND_net), .ATRETURN23(
        GND_net), .ATRETURN45(GND_net), .ATRETURN67(GND_net), 
        .ATRETURN89(GND_net), .VAREF(VAREF), .GNDREF(GND_net), .GDON0(
        GND_net), .GDON1(GND_net), .GDON2(GND_net), .GDON3(GND_net), 
        .GDON4(GND_net), .GDON5(GND_net), .GDON6(GND_net), .GDON7(
        GND_net), .GDON8(GND_net), .GDON9(GND_net), .CMSTB0(
        CM_STB_net_0), .CMSTB1(CM_STB_net_1), .CMSTB2(CM_STB_net_2), 
        .CMSTB3(CM_STB_net_3), .CMSTB4(CM_STB_net_4), .CMSTB5(
        CM_STB_net_5), .CMSTB6(CM_STB_net_6), .CMSTB7(CM_STB_net_7), 
        .CMSTB8(CM_STB_net_8), .CMSTB9(CM_STB_net_9), .TMSTB0(
        TM_STB_net_0), .TMSTB1(TM_STB_net_1), .TMSTB2(TM_STB_net_2), 
        .TMSTB3(TM_STB_net_3), .TMSTB4(TM_STB_net_4), .TMSTB5(
        TM_STB_net_5), .TMSTB6(TM_STB_net_6), .TMSTB7(TM_STB_net_7), 
        .TMSTB8(TM_STB_net_8), .TMSTB9(TM_STB_net_9), .TMSTBINT(
        TM_STB_net_10), .RESULT({ADCRESULT_net[11], ADCRESULT_net[10], 
        ADCRESULT_net[9], ADCRESULT_net[8], ADCRESULT_net[7], 
        ADCRESULT_net[6], ADCRESULT_net[5], ADCRESULT_net[4], 
        ADCRESULT_net[3], ADCRESULT_net[2], ADCRESULT_net[1], 
        ADCRESULT_net[0]}), .ACMRDATA({nc0, nc1, nc2, nc3, nc4, nc5, 
        nc6, nc7}), .ACMWDATA({INIT_DATA[7], INIT_DATA[6], 
        INIT_DATA[5], INIT_DATA[4], INIT_DATA[3], INIT_DATA[2], 
        INIT_DATA[1], INIT_DATA[0]}), .ACMADDR({INIT_ADDR[7], 
        INIT_ADDR[6], INIT_ADDR[5], INIT_ADDR[4], INIT_ADDR[3], 
        INIT_ADDR[2], INIT_ADDR[1], INIT_ADDR[0]}), .STC({
        ADC_STC_net[7], ADC_STC_net[6], ADC_STC_net[5], ADC_STC_net[4], 
        ADC_STC_net[3], ADC_STC_net[2], ADC_STC_net[1], ADC_STC_net[0]})
        , .TVC({ADC_TVC_net[7], ADC_TVC_net[6], ADC_TVC_net[5], 
        ADC_TVC_net[4], ADC_TVC_net[3], ADC_TVC_net[2], ADC_TVC_net[1], 
        ADC_TVC_net[0]}), .CHNUMBER({ADC_CHNUMBER[4], ADC_CHNUMBER[3], 
        ADC_CHNUMBER[2], ADC_CHNUMBER[1], ADC_CHNUMBER[0]}), .MODE({
        ADC_MODE_net[3], ADC_MODE_net[2], ADC_MODE_net[1], 
        ADC_MODE_net[0]}), .RTCXTLMODE({nc8, nc9}), .ACMRESET(
        SYS_RESET), .ACMCLK(SYS_CLK), .ACMWEN(INIT_ACM_WEN_OR_net), 
        .VAREFSEL(ADC_VREFSEL_net), .DATAVALID(DATAVALID_CALIB_net), 
        .CALIBRATE(ADC_CALIBRATE_net), .SAMPLE(), .BUSY(ADC_BUSY_net), 
        .PWRDWN(ADC_PDOWN_net), .SYSCLK(SYS_CLK), .ADCRESET(
        ADC_RESET_net), .ADCSTART(ADC_START_net), .RTCMATCH(), 
        .RTCPSMMATCH(), .RTCXTLSEL(), .RTCCLK(GND_net));
    INBUF_A AT5_PAD (.PAD(VIN), .Y(AT5_net));
    AnalogSystem_calibip_wrapper AnalogSystem_calibip_wrapper_inst (
        .CLK(SYS_CLK), .RESET_N(SYS_RESET), .INIT_CLK(SYS_CLK), 
        .INIT_DATA({INIT_DATA[8], INIT_DATA[7], INIT_DATA[6], 
        INIT_DATA[5], INIT_DATA[4], INIT_DATA[3], INIT_DATA[2], 
        INIT_DATA[1], INIT_DATA[0]}), .INIT_ADDR({INIT_ADDR[10], 
        INIT_ADDR[9], INIT_ADDR[8], INIT_ADDR[7], INIT_ADDR[6], 
        INIT_ADDR[5], INIT_ADDR[4], INIT_ADDR[3], INIT_ADDR[2], 
        INIT_ADDR[1], INIT_ADDR[0]}), .INIT_ROM_WEN(INIT_CALIBROM_WEN), 
        .INIT_COEFF_WEN(INIT_CALIBCOEFF_WEN), .INIT_DONE(INIT_DONE), 
        .ADC_START(ADC_START_net), .CH_NUMBER({ADC_CHNUMBER[4], 
        ADC_CHNUMBER[3], ADC_CHNUMBER[2], ADC_CHNUMBER[1], 
        ADC_CHNUMBER[0]}), .BUSY(ADC_BUSY_net), .DATAVALID(
        DATAVALID_CALIB_net), .ADC_RESULT({ADCRESULT_net[11], 
        ADCRESULT_net[10], ADCRESULT_net[9], ADCRESULT_net[8], 
        ADCRESULT_net[7], ADCRESULT_net[6], ADCRESULT_net[5], 
        ADCRESULT_net[4], ADCRESULT_net[3], ADCRESULT_net[2], 
        ADCRESULT_net[1], ADCRESULT_net[0]}), .ADC_CH_ERROR(), 
        .BUSY_CALIB(ADC_BUSY_CALIB_net), .ADC_RESULT_CALIB({
        ADC_RESULT[11], ADC_RESULT[10], ADC_RESULT[9], ADC_RESULT[8], 
        ADC_RESULT[7], ADC_RESULT[6], ADC_RESULT[5], ADC_RESULT[4], 
        ADC_RESULT[3], ADC_RESULT[2], ADC_RESULT[1], ADC_RESULT[0]}), 
        .DATAVALID_CALIB(DATAVALID));
    AnalogSystem_assc_wrapper AnalogSystem_assc_wrapper_inst (.CLK(
        SYS_CLK), .NRESET(SYS_RESET), .INIT_ADDR({INIT_ADDR[8], 
        INIT_ADDR[7], INIT_ADDR[6], INIT_ADDR[5], INIT_ADDR[4], 
        INIT_ADDR[3], INIT_ADDR[2], INIT_ADDR[1], INIT_ADDR[0]}), 
        .INIT_ASSC_WR(INIT_ASSC_WEN), .INIT_DI({INIT_DATA[8], 
        INIT_DATA[7], INIT_DATA[6], INIT_DATA[5], INIT_DATA[4], 
        INIT_DATA[3], INIT_DATA[2], INIT_DATA[1], INIT_DATA[0]}), 
        .INIT_DONE(INIT_DONE), .USER_ASSC_ADDR({GND_net, GND_net, 
        GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, GND_net})
        , .USER_ASSC_RD(GND_net), .EV_ASSC_ADDR({GND_net, GND_net, 
        GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, GND_net})
        , .EV_ASSC_RD(GND_net), .EV_EVFLAG(GND_net), .EV_DONE(GND_net), 
        .TR_TRFLAG(GND_net), .TR_DONE(GND_net), .ASSC_SEQIN({
        ASSC_SEQIN[5], ASSC_SEQIN[4], ASSC_SEQIN[3], ASSC_SEQIN[2], 
        ASSC_SEQIN[1], ASSC_SEQIN[0]}), .ASSC_RAM_DO_B({
        ASSC_RAM_DO_B_net[8], ASSC_RAM_DO_B_net[7], 
        ASSC_RAM_DO_B_net[6], ASSC_RAM_DO_B_net[5], 
        ASSC_RAM_DO_B_net[4], ASSC_RAM_DO_B_net[3], 
        ASSC_RAM_DO_B_net[2], ASSC_RAM_DO_B_net[1], 
        ASSC_RAM_DO_B_net[0]}), .ASSC_XMODE(ASSC_XMODE), .ASSC_XTRIG(
        ASSC_XTRIG), .ASSC_SEQJUMP(ASSC_SEQJUMP), .ADC_CALIBRATE(
        ADC_CALIBRATE_net), .ADC_BUSY(ADC_BUSY_CALIB_net), .ADC_RESULT({
        ADC_RESULT[11], ADC_RESULT[10], ADC_RESULT[9], ADC_RESULT[8], 
        ADC_RESULT[7], ADC_RESULT[6], ADC_RESULT[5], ADC_RESULT[4], 
        ADC_RESULT[3], ADC_RESULT[2], ADC_RESULT[1], ADC_RESULT[0]}), 
        .USER_ASSC_RAM_BUSY(), .ASSC_RAM_ADDR_A({
        ASSC_RAM_ADDR_A_net[8], ASSC_RAM_ADDR_A_net[7], 
        ASSC_RAM_ADDR_A_net[6], ASSC_RAM_ADDR_A_net[5], 
        ASSC_RAM_ADDR_A_net[4], ASSC_RAM_ADDR_A_net[3], 
        ASSC_RAM_ADDR_A_net[2], ASSC_RAM_ADDR_A_net[1], 
        ASSC_RAM_ADDR_A_net[0]}), .ASSC_RAM_RW_A(ASSC_RAM_RW_A_net), 
        .ASSC_RAM_CSN_A(ASSC_RAM_CSN_A_net), .ASSC_RAM_DI_A({
        ASSC_RAM_DI_A_net[8], ASSC_RAM_DI_A_net[7], 
        ASSC_RAM_DI_A_net[6], ASSC_RAM_DI_A_net[5], 
        ASSC_RAM_DI_A_net[4], ASSC_RAM_DI_A_net[3], 
        ASSC_RAM_DI_A_net[2], ASSC_RAM_DI_A_net[1], 
        ASSC_RAM_DI_A_net[0]}), .ASSC_RAM_ADDR_B({
        ASSC_RAM_ADDR_B_net[8], ASSC_RAM_ADDR_B_net[7], 
        ASSC_RAM_ADDR_B_net[6], ASSC_RAM_ADDR_B_net[5], 
        ASSC_RAM_ADDR_B_net[4], ASSC_RAM_ADDR_B_net[3], 
        ASSC_RAM_ADDR_B_net[2], ASSC_RAM_ADDR_B_net[1], 
        ASSC_RAM_ADDR_B_net[0]}), .ASSC_RAM_RW_B(ASSC_RAM_RW_B_net), 
        .ASSC_RAM_CSN_B(ASSC_RAM_CSN_B_net), .ASSC_RAM_DI_B({
        ASSC_RAM_DI_B_net[8], ASSC_RAM_DI_B_net[7], 
        ASSC_RAM_DI_B_net[6], ASSC_RAM_DI_B_net[5], 
        ASSC_RAM_DI_B_net[4], ASSC_RAM_DI_B_net[3], 
        ASSC_RAM_DI_B_net[2], ASSC_RAM_DI_B_net[1], 
        ASSC_RAM_DI_B_net[0]}), .ASSC_SEQOUT({ASSC_SEQOUT[5], 
        ASSC_SEQOUT[4], ASSC_SEQOUT[3], ASSC_SEQOUT[2], ASSC_SEQOUT[1], 
        ASSC_SEQOUT[0]}), .ASSC_SEQCHANGE(ASSC_SEQCHANGE), .ASSC_DONE(
        ASSC_DONE), .ASSC_WAIT(ASSC_WAIT), .ASSC_SAMPFLAG(
        ASSC_SAMPFLAG), .ASSC_CHSAT(ASSC_CHSAT), .ASSC_CHLATD(
        ASSC_CHLATD), .ADC_START(ADC_START_net), .ADC_PDOWN(
        ADC_PDOWN_net), .ADC_RESET(ADC_RESET_net), .ADC_MODE({
        ADC_MODE_net[3], ADC_MODE_net[2], ADC_MODE_net[1], 
        ADC_MODE_net[0]}), .ADC_VREFSEL(ADC_VREFSEL_net), .ADC_CHNR({
        ADC_CHNUMBER[4], ADC_CHNUMBER[3], ADC_CHNUMBER[2], 
        ADC_CHNUMBER[1], ADC_CHNUMBER[0]}), .ADC_STC({ADC_STC_net[7], 
        ADC_STC_net[6], ADC_STC_net[5], ADC_STC_net[4], ADC_STC_net[3], 
        ADC_STC_net[2], ADC_STC_net[1], ADC_STC_net[0]}), .ADC_DVC({
        ADC_TVC_net[7], ADC_TVC_net[6], ADC_TVC_net[5], ADC_TVC_net[4], 
        ADC_TVC_net[3], ADC_TVC_net[2], ADC_TVC_net[1], ADC_TVC_net[0]})
        , .CM_STB({CM_STB_net_9, CM_STB_net_8, CM_STB_net_7, 
        CM_STB_net_6, CM_STB_net_5, CM_STB_net_4, CM_STB_net_3, 
        CM_STB_net_2, CM_STB_net_1, CM_STB_net_0}), .TM_STB({
        TM_STB_net_10, TM_STB_net_9, TM_STB_net_8, TM_STB_net_7, 
        TM_STB_net_6, TM_STB_net_5, TM_STB_net_4, TM_STB_net_3, 
        TM_STB_net_2, TM_STB_net_1, TM_STB_net_0}), 
        .ASSC_RAM_WR_BUSY_B());
    AnalogSystem_assc_ram AnalogSystem_assc_ram_inst (.DATAA({
        ASSC_RAM_DI_A_net[8], ASSC_RAM_DI_A_net[7], 
        ASSC_RAM_DI_A_net[6], ASSC_RAM_DI_A_net[5], 
        ASSC_RAM_DI_A_net[4], ASSC_RAM_DI_A_net[3], 
        ASSC_RAM_DI_A_net[2], ASSC_RAM_DI_A_net[1], 
        ASSC_RAM_DI_A_net[0]}), .ADDRESSA({ASSC_RAM_ADDR_A_net[8], 
        ASSC_RAM_ADDR_A_net[7], ASSC_RAM_ADDR_A_net[6], 
        ASSC_RAM_ADDR_A_net[5], ASSC_RAM_ADDR_A_net[4], 
        ASSC_RAM_ADDR_A_net[3], ASSC_RAM_ADDR_A_net[2], 
        ASSC_RAM_ADDR_A_net[1], ASSC_RAM_ADDR_A_net[0]}), .RWA(
        ASSC_RAM_RW_A_net), .BLKA(ASSC_RAM_CSN_A_net), .DATAB({
        ASSC_RAM_DI_B_net[8], ASSC_RAM_DI_B_net[7], 
        ASSC_RAM_DI_B_net[6], ASSC_RAM_DI_B_net[5], 
        ASSC_RAM_DI_B_net[4], ASSC_RAM_DI_B_net[3], 
        ASSC_RAM_DI_B_net[2], ASSC_RAM_DI_B_net[1], 
        ASSC_RAM_DI_B_net[0]}), .ADDRESSB({ASSC_RAM_ADDR_B_net[8], 
        ASSC_RAM_ADDR_B_net[7], ASSC_RAM_ADDR_B_net[6], 
        ASSC_RAM_ADDR_B_net[5], ASSC_RAM_ADDR_B_net[4], 
        ASSC_RAM_ADDR_B_net[3], ASSC_RAM_ADDR_B_net[2], 
        ASSC_RAM_ADDR_B_net[1], ASSC_RAM_ADDR_B_net[0]}), .RWB(
        ASSC_RAM_RW_B_net), .BLKB(ASSC_RAM_CSN_B_net), .CLOCK(SYS_CLK), 
        .RESET(SYS_RESET), .QA({nc10, nc11, nc12, nc13, nc14, nc15, 
        nc16, nc17, nc18}), .QB({ASSC_RAM_DO_B_net[8], 
        ASSC_RAM_DO_B_net[7], ASSC_RAM_DO_B_net[6], 
        ASSC_RAM_DO_B_net[5], ASSC_RAM_DO_B_net[4], 
        ASSC_RAM_DO_B_net[3], ASSC_RAM_DO_B_net[2], 
        ASSC_RAM_DO_B_net[1], ASSC_RAM_DO_B_net[0]}));
    GND GND_power_inst1 (.Y(GND_power_net1));
    VCC VCC_power_inst1 (.Y(VCC_power_net1));
    
endmodule

// _Disclaimer: Please leave the following comments in the file, they are for internal purposes only._

// _CFG_File_Contents_

// 
// adc_set_engine -hdl VERILOG \
//                -toplevel "AnalogSystem" \
//                -workdir {.} \
//                -commondir {./common} \
//                -die "M7AFS600" \
//                -package "484 FBGA" \
//                -memory_file_format INTELHEX \
//                -verbosity 0
// 
// adc_set_system -system_frequency " 9.21 Mhz" \
//                -mode 12 \
//                -calibrate 1 \
//                -include_calibration_block 1 \
//                -calibration_propagate_saturation 1 \
//                -allow_assc_repeat 0 \
//                -export_assc_status 1 \
//                -export_smev_status 0 \
//                -export_assc_ram 0 \
//                -export_smev_ram 0 \
//                -export_adc_result 1 \
//                -export_adc_status 0 \
//                -export_acm_clk 0 \
//                -export_acm_bus 0 \
//                -export_acm_bus_independent 0 \
//                -system_configuration "ASSC_ONLY" 
// 
// adc_set_rtc -enable 0 \
//             -osc_mode "EXTERNAL_CRYSTAL" \
//             -rtc_frequency " 32.000 Khz" \
//             -alarm_day 0 \
//             -alarm_hour 0 \
//             -alarm_minute 0 \
//             -alarm_second 0 \
//             -alarm_millisecond 0 \
//             -alarm_microsecond 0 \
//             -reset_count_on_match 1 \
//             -enable_vr 0
// 
// adc_set_voltage_channel -channel_name VIN \
//                         -maximum_supply_voltage " 3.900000 V" \
//                         -pre_scalar " 4.000000 V" \
//                         -post_scalar " 4.000000 V" \
//                         -use_prescalar 1 \
//                         -number_of_samples_to_average 1 \
//                         -initial_averaging_value " 0.000000 V" \
//                         -settling_time " 10.000 us" \
//                         -package_pin V13
// 
// 
// adc_set_sequencer -use_external_trigger 1 
// 
// adc_set_sequencer_procedure -procedure_name Main \
//                             -lock 1 \
//                             -start_slot 0
// 
// adc_set_sequencer_procedure_req -procedure_name Main \
//                                 -signal_name VIN 
// 
// adc_set_sequencer_procedure_slot -procedure_name Main \
//                                  -logical_slot 0 \
//                                  -function SAMPLE_JUMP \
//                                  -signal_name VIN \
//                                  -jump_procedure_name Main \
//                                  -repeat 0 
// 
// adc_set_sequencer_procedure -procedure_name DummyToExposeXTRIG \
//                             -lock 1 \
//                             -start_slot 1
// 
// adc_set_sequencer_procedure_req -procedure_name DummyToExposeXTRIG \
//                                 -signal_name VIN 
// 
// adc_set_sequencer_procedure_slot -procedure_name DummyToExposeXTRIG \
//                                  -logical_slot 0 \
//                                  -function SAMPLE_JUMP \
//                                  -signal_name VIN \
//                                  -jump_procedure_name DummyToExposeXTRIG \
//                                  -repeat 0 

// _GEN_File_Contents_

// DESIGN:AnalogSystem
// DESDIR:C:/data/Designs/ClosedLoopTrimDemo/smartgen\AnalogSystem
// FAM:Fusion
// MGNCMPL:F
// MGNTIMER:F
// OUTFORMAT:Verilog
// LPMTYPE:LPM_ANALOGSYS
// LPM_HINT:NONE
// CONFIGFILE:AnalogSystem.cfg

// _End_Comments_

