module AnalogSystem_calibip_wrapper ( CLK,
               RESET_N,
               INIT_CLK,
               INIT_DATA,
               INIT_ADDR,
               INIT_ROM_WEN,
               INIT_COEFF_WEN,
               INIT_DONE,
               ADC_CH_ERROR,
               BUSY_CALIB,
               DATAVALID_CALIB,
               ADC_RESULT_CALIB,
               ADC_START,
               CH_NUMBER,
               BUSY,
               DATAVALID,
               ADC_RESULT );

    input CLK;
    input RESET_N;
    input INIT_CLK;
    input[8 : 0] INIT_DATA;
    input[10 : 0] INIT_ADDR;
    input INIT_ROM_WEN;
    input INIT_COEFF_WEN;
    input INIT_DONE;
    output ADC_CH_ERROR;
    output BUSY_CALIB;
    output DATAVALID_CALIB;
    output[11 : 0] ADC_RESULT_CALIB;
    input ADC_START;
    input[4 : 0] CH_NUMBER;
    input BUSY;
    input DATAVALID;
    input[11 : 0] ADC_RESULT;

    wire CLK;
    wire RESET_N;
    wire INIT_CLK;
    wire [8 : 0]INIT_DATA;
    wire [10 : 0]INIT_ADDR;
    wire INIT_ROM_WEN;
    wire INIT_COEFF_WEN;
    wire INIT_DONE;
    wire ADC_CH_ERROR;
    wire BUSY_CALIB;
    wire DATAVALID_CALIB;
    wire [11 : 0]ADC_RESULT_CALIB;
    wire ADC_START;
    wire [4 : 0]CH_NUMBER;
    wire BUSY;
    wire DATAVALID;
    wire [11 : 0]ADC_RESULT;

    defparam user_AnalogSystem_calibip_wrapper.G_DEBUG = 0;
    defparam user_AnalogSystem_calibip_wrapper.G_USE_SRAM_TILES = 0;
    defparam user_AnalogSystem_calibip_wrapper.G_WIDTH_GAIN = 11;
    defparam user_AnalogSystem_calibip_wrapper.G_WIDTH_OFFSET = 8;
    defparam user_AnalogSystem_calibip_wrapper.G_ADC_BITS_8_10_12 = 0;
    defparam user_AnalogSystem_calibip_wrapper.G_OPTIMIZATION = 0;
    defparam user_AnalogSystem_calibip_wrapper.G_SATURATE = 1;

    calibip user_AnalogSystem_calibip_wrapper ( 
	.CLK (CLK),
	.RESET_N (RESET_N),
	.INIT_CLK (INIT_CLK),
	.INIT_DATA (INIT_DATA),
	.INIT_ADDR (INIT_ADDR),
	.INIT_ROM_WEN (INIT_ROM_WEN),
	.INIT_COEFF_WEN (INIT_COEFF_WEN),
	.INIT_DONE (INIT_DONE),
	.ADC_CH_ERROR (ADC_CH_ERROR),
	.BUSY_CALIB (BUSY_CALIB),
	.DATAVALID_CALIB (DATAVALID_CALIB),
	.ADC_RESULT_CALIB (ADC_RESULT_CALIB),
	.ADC_START (ADC_START),
	.CH_NUMBER (CH_NUMBER),
	.BUSY (BUSY),
	.DATAVALID (DATAVALID),
	.ADC_RESULT (ADC_RESULT) );

endmodule