`timescale 1 ns/100 ps
// Version: 8.3 8.3.0.22


module FlashMemorySystem(
       INIT_CLK,
       SYS_RESET,
       INIT_POWER_UP,
       INIT_DONE,
       INIT_DATA,
       INIT_ADDR,
       INIT_ACM_WEN,
       INIT_ASSC_WEN,
       INIT_CALIBROM_WEN,
       INIT_CALIBCOEFF_WEN,
       USER_CLK,
       USER_ADD,
       USER_AUX_BLOCK,
       USER_DATA,
       USER_DISCARD_PAGE,
       USER_ERASE_PAGE,
       USER_OVERWRITE_PAGE,
       USER_OVERWRITE_PROT,
       USER_PAGELOSS_PROT,
       USER_PROGRAM,
       USER_READ,
       USER_READ_NEXT,
       USER_LOCK,
       USER_SPARE_PAGE,
       USER_UNPROT_PAGE,
       USER_WIDTH,
       USER_WRITE,
       USER_DOUT,
       USER_PAGE_STATUS,
       USER_DAT_VAL,
       USER_NVM_STATUS
    );
input  INIT_CLK;
input  SYS_RESET;
input  INIT_POWER_UP;
output INIT_DONE;
output [8:0] INIT_DATA;
output [10:0] INIT_ADDR;
output INIT_ACM_WEN;
output INIT_ASSC_WEN;
output INIT_CALIBROM_WEN;
output INIT_CALIBCOEFF_WEN;
input  USER_CLK;
input  [17:0] USER_ADD;
input  USER_AUX_BLOCK;
input  [31:0] USER_DATA;
input  USER_DISCARD_PAGE;
input  USER_ERASE_PAGE;
input  USER_OVERWRITE_PAGE;
input  USER_OVERWRITE_PROT;
input  USER_PAGELOSS_PROT;
input  USER_PROGRAM;
input  USER_READ;
input  USER_READ_NEXT;
input  USER_LOCK;
input  USER_SPARE_PAGE;
input  USER_UNPROT_PAGE;
input  [1:0] USER_WIDTH;
input  USER_WRITE;
output [31:0] USER_DOUT;
input  USER_PAGE_STATUS;
output USER_DAT_VAL;
output [1:0] USER_NVM_STATUS;

    wire GND_net, VCC_net, NVM_LOCK_net, NVM_AUX_BLOCK_net;
    wire [31:0] NVM_DAT_TO_net;
    wire [17:0] NVM_ADD_net;
    wire [1:0] NVM_WIDTH_net;
    wire NVM_REN_net, NVM_READ_NEXT_net, NVM_WRITE_net, 
        NVM_SPARE_PAGE_net, NVM_PROGRAM_net, NVM_ERASE_PAGE_net, 
        NVM_UNPROT_PAGE_net, NVM_DISCARD_PAGE_net, 
        NVM_OVERWRITE_PROT_net, NVM_PAGELOSS_PROT_net, 
        NVM_PAGE_STATUS_net, NVM_OVERWRITE_PAGE_net;
    wire [31:0] NVM_DAT_FROM_net;
    wire NVM_BUSY_net;
    wire [1:0] NVM_STATUS_net;
    wire NVM_CLK_net;
    wire GND_power_net1;
    wire VCC_power_net1;
    assign GND_net = GND_power_net1;
    assign VCC_net = VCC_power_net1;
    
    FlashMemorySystem_init_wrapper FlashMemorySystem_init_wrapper_inst 
        (.CLK(INIT_CLK), .USER_CLK(USER_CLK), .NRESET(SYS_RESET), 
        .CLIENT_DIN({GND_net, GND_net, GND_net, GND_net, GND_net, 
        GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, 
        GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, 
        GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, 
        GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, GND_net, 
        GND_net, GND_net, GND_net}), .CLIENT_AVAIL({GND_net, GND_net, 
        GND_net, GND_net}), .USER_ADD({USER_ADD[17], USER_ADD[16], 
        USER_ADD[15], USER_ADD[14], USER_ADD[13], USER_ADD[12], 
        USER_ADD[11], USER_ADD[10], USER_ADD[9], USER_ADD[8], 
        USER_ADD[7], USER_ADD[6], USER_ADD[5], USER_ADD[4], 
        USER_ADD[3], USER_ADD[2], USER_ADD[1], USER_ADD[0]}), 
        .USER_AUX_BLOCK(USER_AUX_BLOCK), .USER_DATA({USER_DATA[31], 
        USER_DATA[30], USER_DATA[29], USER_DATA[28], USER_DATA[27], 
        USER_DATA[26], USER_DATA[25], USER_DATA[24], USER_DATA[23], 
        USER_DATA[22], USER_DATA[21], USER_DATA[20], USER_DATA[19], 
        USER_DATA[18], USER_DATA[17], USER_DATA[16], USER_DATA[15], 
        USER_DATA[14], USER_DATA[13], USER_DATA[12], USER_DATA[11], 
        USER_DATA[10], USER_DATA[9], USER_DATA[8], USER_DATA[7], 
        USER_DATA[6], USER_DATA[5], USER_DATA[4], USER_DATA[3], 
        USER_DATA[2], USER_DATA[1], USER_DATA[0]}), .USER_DISCARD_PAGE(
        USER_DISCARD_PAGE), .USER_ERASE_PAGE(USER_ERASE_PAGE), 
        .USER_OVERWRITE_PAGE(USER_OVERWRITE_PAGE), 
        .USER_OVERWRITE_PROT(USER_OVERWRITE_PROT), .USER_PAGE_STATUS(
        USER_PAGE_STATUS), .USER_PAGELOSS_PROT(USER_PAGELOSS_PROT), 
        .USER_PROGRAM(USER_PROGRAM), .USER_READ(USER_READ), 
        .USER_READ_NEXT(USER_READ_NEXT), .USER_LOCK(USER_LOCK), 
        .USER_SPARE_PAGE(USER_SPARE_PAGE), .USER_UNPROT_PAGE(
        USER_UNPROT_PAGE), .USER_WIDTH({USER_WIDTH[1], USER_WIDTH[0]}), 
        .USER_WRITE(USER_WRITE), .USER_SIX_CYCLE(GND_net), 
        .CLIENT_UPDATE(GND_net), .POWER_UP(INIT_POWER_UP), .NVM_BUSY(
        NVM_BUSY_net), .NVM_DAT_FROM({NVM_DAT_FROM_net[31], 
        NVM_DAT_FROM_net[30], NVM_DAT_FROM_net[29], 
        NVM_DAT_FROM_net[28], NVM_DAT_FROM_net[27], 
        NVM_DAT_FROM_net[26], NVM_DAT_FROM_net[25], 
        NVM_DAT_FROM_net[24], NVM_DAT_FROM_net[23], 
        NVM_DAT_FROM_net[22], NVM_DAT_FROM_net[21], 
        NVM_DAT_FROM_net[20], NVM_DAT_FROM_net[19], 
        NVM_DAT_FROM_net[18], NVM_DAT_FROM_net[17], 
        NVM_DAT_FROM_net[16], NVM_DAT_FROM_net[15], 
        NVM_DAT_FROM_net[14], NVM_DAT_FROM_net[13], 
        NVM_DAT_FROM_net[12], NVM_DAT_FROM_net[11], 
        NVM_DAT_FROM_net[10], NVM_DAT_FROM_net[9], NVM_DAT_FROM_net[8], 
        NVM_DAT_FROM_net[7], NVM_DAT_FROM_net[6], NVM_DAT_FROM_net[5], 
        NVM_DAT_FROM_net[4], NVM_DAT_FROM_net[3], NVM_DAT_FROM_net[2], 
        NVM_DAT_FROM_net[1], NVM_DAT_FROM_net[0]}), .NVM_STATUS({
        NVM_STATUS_net[1], NVM_STATUS_net[0]}), .NVM_ADD({
        NVM_ADD_net[17], NVM_ADD_net[16], NVM_ADD_net[15], 
        NVM_ADD_net[14], NVM_ADD_net[13], NVM_ADD_net[12], 
        NVM_ADD_net[11], NVM_ADD_net[10], NVM_ADD_net[9], 
        NVM_ADD_net[8], NVM_ADD_net[7], NVM_ADD_net[6], NVM_ADD_net[5], 
        NVM_ADD_net[4], NVM_ADD_net[3], NVM_ADD_net[2], NVM_ADD_net[1], 
        NVM_ADD_net[0]}), .NVM_AUX_BLOCK(NVM_AUX_BLOCK_net), 
        .NVM_DAT_TO({NVM_DAT_TO_net[31], NVM_DAT_TO_net[30], 
        NVM_DAT_TO_net[29], NVM_DAT_TO_net[28], NVM_DAT_TO_net[27], 
        NVM_DAT_TO_net[26], NVM_DAT_TO_net[25], NVM_DAT_TO_net[24], 
        NVM_DAT_TO_net[23], NVM_DAT_TO_net[22], NVM_DAT_TO_net[21], 
        NVM_DAT_TO_net[20], NVM_DAT_TO_net[19], NVM_DAT_TO_net[18], 
        NVM_DAT_TO_net[17], NVM_DAT_TO_net[16], NVM_DAT_TO_net[15], 
        NVM_DAT_TO_net[14], NVM_DAT_TO_net[13], NVM_DAT_TO_net[12], 
        NVM_DAT_TO_net[11], NVM_DAT_TO_net[10], NVM_DAT_TO_net[9], 
        NVM_DAT_TO_net[8], NVM_DAT_TO_net[7], NVM_DAT_TO_net[6], 
        NVM_DAT_TO_net[5], NVM_DAT_TO_net[4], NVM_DAT_TO_net[3], 
        NVM_DAT_TO_net[2], NVM_DAT_TO_net[1], NVM_DAT_TO_net[0]}), 
        .NVM_DISCARD_PAGE(NVM_DISCARD_PAGE_net), .NVM_ERASE_PAGE(
        NVM_ERASE_PAGE_net), .NVM_OVERWRITE_PAGE(
        NVM_OVERWRITE_PAGE_net), .NVM_OVERWRITE_PROT(
        NVM_OVERWRITE_PROT_net), .NVM_PAGE_STATUS(NVM_PAGE_STATUS_net), 
        .NVM_PAGELOSS_PROT(NVM_PAGELOSS_PROT_net), .NVM_PROGRAM(
        NVM_PROGRAM_net), .NVM_READ(NVM_REN_net), .NVM_READ_NEXT(
        NVM_READ_NEXT_net), .NVM_LOCK(NVM_LOCK_net), .NVM_SPARE_PAGE(
        NVM_SPARE_PAGE_net), .NVM_UNPROT_PAGE(NVM_UNPROT_PAGE_net), 
        .NVM_WIDTH({NVM_WIDTH_net[1], NVM_WIDTH_net[0]}), .NVM_WRITE(
        NVM_WRITE_net), .NVM_SIX_CYCLE(), .WORD_COUNT({INIT_ADDR[10], 
        INIT_ADDR[9], INIT_ADDR[8], INIT_ADDR[7], INIT_ADDR[6], 
        INIT_ADDR[5], INIT_ADDR[4], INIT_ADDR[3], INIT_ADDR[2], 
        INIT_ADDR[1], INIT_ADDR[0]}), .CLIENT_DOUT({INIT_DATA[8], 
        INIT_DATA[7], INIT_DATA[6], INIT_DATA[5], INIT_DATA[4], 
        INIT_DATA[3], INIT_DATA[2], INIT_DATA[1], INIT_DATA[0]}), 
        .CLIENT_DAT_VAL({INIT_CALIBCOEFF_WEN, INIT_CALIBROM_WEN, 
        INIT_ASSC_WEN, INIT_ACM_WEN}), .SAVE_COMPLETE(), .INIT_DONE(
        INIT_DONE), .USER_DOUT({USER_DOUT[31], USER_DOUT[30], 
        USER_DOUT[29], USER_DOUT[28], USER_DOUT[27], USER_DOUT[26], 
        USER_DOUT[25], USER_DOUT[24], USER_DOUT[23], USER_DOUT[22], 
        USER_DOUT[21], USER_DOUT[20], USER_DOUT[19], USER_DOUT[18], 
        USER_DOUT[17], USER_DOUT[16], USER_DOUT[15], USER_DOUT[14], 
        USER_DOUT[13], USER_DOUT[12], USER_DOUT[11], USER_DOUT[10], 
        USER_DOUT[9], USER_DOUT[8], USER_DOUT[7], USER_DOUT[6], 
        USER_DOUT[5], USER_DOUT[4], USER_DOUT[3], USER_DOUT[2], 
        USER_DOUT[1], USER_DOUT[0]}), .USER_DAT_VAL(USER_DAT_VAL), 
        .USER_NVM_STATUS({USER_NVM_STATUS[1], USER_NVM_STATUS[0]}), 
        .NVM_CLK(NVM_CLK_net));
    NVM #( .MEMORYFILE("FlashMemorySystem.mem"), .ACT_PROGFILE("FlashMemorySystem.efc")
        , .ACT_CALIBRATIONDATA(1) )  NVM_INST_CALIBRATIONDATA (.RD({
        NVM_DAT_FROM_net[31], NVM_DAT_FROM_net[30], 
        NVM_DAT_FROM_net[29], NVM_DAT_FROM_net[28], 
        NVM_DAT_FROM_net[27], NVM_DAT_FROM_net[26], 
        NVM_DAT_FROM_net[25], NVM_DAT_FROM_net[24], 
        NVM_DAT_FROM_net[23], NVM_DAT_FROM_net[22], 
        NVM_DAT_FROM_net[21], NVM_DAT_FROM_net[20], 
        NVM_DAT_FROM_net[19], NVM_DAT_FROM_net[18], 
        NVM_DAT_FROM_net[17], NVM_DAT_FROM_net[16], 
        NVM_DAT_FROM_net[15], NVM_DAT_FROM_net[14], 
        NVM_DAT_FROM_net[13], NVM_DAT_FROM_net[12], 
        NVM_DAT_FROM_net[11], NVM_DAT_FROM_net[10], 
        NVM_DAT_FROM_net[9], NVM_DAT_FROM_net[8], NVM_DAT_FROM_net[7], 
        NVM_DAT_FROM_net[6], NVM_DAT_FROM_net[5], NVM_DAT_FROM_net[4], 
        NVM_DAT_FROM_net[3], NVM_DAT_FROM_net[2], NVM_DAT_FROM_net[1], 
        NVM_DAT_FROM_net[0]}), .BUSY(NVM_BUSY_net), .STATUS({
        NVM_STATUS_net[1], NVM_STATUS_net[0]}), .ADDR({NVM_ADD_net[17], 
        NVM_ADD_net[16], NVM_ADD_net[15], NVM_ADD_net[14], 
        NVM_ADD_net[13], NVM_ADD_net[12], NVM_ADD_net[11], 
        NVM_ADD_net[10], NVM_ADD_net[9], NVM_ADD_net[8], 
        NVM_ADD_net[7], NVM_ADD_net[6], NVM_ADD_net[5], NVM_ADD_net[4], 
        NVM_ADD_net[3], NVM_ADD_net[2], NVM_ADD_net[1], NVM_ADD_net[0]})
        , .WD({NVM_DAT_TO_net[31], NVM_DAT_TO_net[30], 
        NVM_DAT_TO_net[29], NVM_DAT_TO_net[28], NVM_DAT_TO_net[27], 
        NVM_DAT_TO_net[26], NVM_DAT_TO_net[25], NVM_DAT_TO_net[24], 
        NVM_DAT_TO_net[23], NVM_DAT_TO_net[22], NVM_DAT_TO_net[21], 
        NVM_DAT_TO_net[20], NVM_DAT_TO_net[19], NVM_DAT_TO_net[18], 
        NVM_DAT_TO_net[17], NVM_DAT_TO_net[16], NVM_DAT_TO_net[15], 
        NVM_DAT_TO_net[14], NVM_DAT_TO_net[13], NVM_DAT_TO_net[12], 
        NVM_DAT_TO_net[11], NVM_DAT_TO_net[10], NVM_DAT_TO_net[9], 
        NVM_DAT_TO_net[8], NVM_DAT_TO_net[7], NVM_DAT_TO_net[6], 
        NVM_DAT_TO_net[5], NVM_DAT_TO_net[4], NVM_DAT_TO_net[3], 
        NVM_DAT_TO_net[2], NVM_DAT_TO_net[1], NVM_DAT_TO_net[0]}), 
        .DATAWIDTH({NVM_WIDTH_net[1], NVM_WIDTH_net[0]}), .REN(
        NVM_REN_net), .WEN(NVM_WRITE_net), .PROGRAM(NVM_PROGRAM_net), 
        .SPAREPAGE(NVM_SPARE_PAGE_net), .AUXBLOCK(NVM_AUX_BLOCK_net), 
        .READNEXT(NVM_READ_NEXT_net), .ERASEPAGE(NVM_ERASE_PAGE_net), 
        .UNPROTECTPAGE(NVM_UNPROT_PAGE_net), .DISCARDPAGE(
        NVM_DISCARD_PAGE_net), .OVERWRITEPROTECT(
        NVM_OVERWRITE_PROT_net), .PAGELOSSPROTECT(
        NVM_PAGELOSS_PROT_net), .CLK(NVM_CLK_net), .RESET(SYS_RESET), 
        .PAGESTATUS(NVM_PAGE_STATUS_net), .OVERWRITEPAGE(
        NVM_OVERWRITE_PAGE_net), .PIPE(GND_net), .LOCKREQUEST(
        NVM_LOCK_net));
    GND GND_power_inst1 (.Y(GND_power_net1));
    VCC VCC_power_inst1 (.Y(VCC_power_net1));
    
endmodule

// _Disclaimer: Please leave the following comments in the file, they are for internal purposes only._

// _CFG_File_Contents_

// nvm_set_engine \
//    -toplevel "FlashMemorySystem" \
//    -HDL Verilog \
//    -die M7AFS600 \
//    -package "484 FBGA" \
//    -workdir {.} \
//    -commondir {./common} \
//    -verbosity 0
// nvm_set_system \
//    -pipe 0
// nvm_set_analogsystem_config -config_file {AnalogSystem}
// nvm_set_data_storage_client \
//    -client_name "ProcessorCode" \
//    -base_address 0 \
//    -number_of_words 8192 \
//    -word_size 8 \
//    -memory_file_format "INTELHEX" \
//    -memory_file {C:\Data\Designs\ClosedLoopTrimDemo\software\ClosedLoopDemo.hex} \
//    -jtag_read 0\
//    -jtag_write 0\
//    -lock_address 0

// _GEN_File_Contents_

// DESIGN:FlashMemorySystem
// DESDIR:C:/data/Designs/ClosedLoopTrimDemo/smartgen\.\FlashMemorySystem
// FAM:Fusion
// MGNCMPL:F
// MGNTIMER:F
// OUTFORMAT:Verilog
// LPMTYPE:LPM_NVM
// LPMHINT:NONE
// CONFIGFILE:FlashMemorySystem.cfg

// _End_Comments_

