/*
-------------------------------------------------------------------------------
-- (c) Copyright 2008 Actel Corporation
--
-- name:		ClosedLoopTrimmingDemomap.h
-- function:	Memory map and typedef declarations
-- comments:	best viewed with tabstops set to "4"
-- history:		2008/03/24 - SNG created
--
-------------------------------------------------------------------------------
*/


//------------------------------------------------------
//general typedefs
//------------------------------------------------------

typedef unsigned long uint32;
typedef unsigned int uint16;
typedef unsigned char uchar8;

typedef xdata volatile unsigned char *xvchp;
typedef xdata volatile unsigned int  *xvuip;
typedef code  volatile unsigned char *pvchp;
typedef xdata unsigned char           xuchar8;
typedef xdata uint16                  xuint16;

#define CBYTE ((unsigned char volatile code  *) 0)
#define DBYTE ((unsigned char volatile data  *) 0)
#define PBYTE ((unsigned char volatile pdata *) 0)
#define XBYTE ((unsigned char volatile xdata *) 0)

#define CWORD ((unsigned int volatile code  *) 0)
#define DWORD ((unsigned int volatile data  *) 0)
#define PWORD ((unsigned int volatile pdata *) 0)
#define XWORD ((unsigned int volatile xdata *) 0)

// --------------------------------------------------------------
// declare constants
// --------------------------------------------------------------

#define OK  0
#define ERR 1

// internal registers
#define UART2_BASE				0xF600
#define GPIO_BASE				0xF400

// CoreUARTapb registers (communicate with PC)
#define UART2_TXDATA			(XBYTE[UART2_BASE+0])
#define UART2_RXDATA			(XBYTE[UART2_BASE+4])
#define UART2_CTRL1				(XBYTE[UART2_BASE+8])
#define UART2_CTRL2				(XBYTE[UART2_BASE+12])
#define UART2_STAT				(XBYTE[UART2_BASE+16])

// CoreGPIO registers
#define GPIO_REG				(XBYTE[GPIO_BASE+0])
