/*
-------------------------------------------------------------------------------
-- (c) Copyright 2006 Actel Corporation
--
-- name:		main.c
-- function:	routines for sample sysmon design
-- comments:	best viewed with tabstops set to "4"
-- history:		11/30/06 - SNG created
--
-------------------------------------------------------------------------------
*/
#include "reg8051s.h"
//#include <stdlib.h>
//#include <stdio.h>

#include "sysmon682.h"
#include "SW_TIMER.H"
#include "COREAI.H"
#include "COREUARTAPB.H"

// main routine

void main (void)  {
	uint16 ctmp;
	uint16 sample16;
	uchar8 sample8;

	// initialize CoreUARTapb that communicates with PC
	UART2_CTRL1 = 0x09; // baud-rate set to 115.2Kbaud (18.431MHz clock)
	UART2_CTRL2 = 0x01; // no parity, 8-bit data

	// Write a default startup value to all output bits for GPIO_REG
	GPIO_REG = 0xFF;

	// Initialize the ACM
	init_coreai();

	// canned message to screen ...
	tx_str("Core8051s says hello!");

	// infinite loop
	while (1) {
		// check if any characters have been received
		ctmp = rx_char();
		if (ctmp!=0xffff) {
			// ADC conversion for AC5 (Potentiometer)
			prescaled_vmon_conversion(get_chan(AC,5));
			sample16 = get_adc_val();
			// Print result
			tx_str("RX char:");
			tx_char(ctmp);
			txhex(sample16,3);
			// CR/LF
			tx_char(0x0d);tx_char('\n');

			GPIO_REG = 0x00;

		}
	}
}
