/*
-------------------------------------------------------------------------------
-- (c) Copyright 2006 Actel Corporation
--
-- name:		main.c
-- function:	Simplified routines for CLosed Loop Trim Demo
-- comments:	best viewed with tabstops set to "4"
-- history:		2008/03/24 - SNG created
--
-------------------------------------------------------------------------------
*/
#include "reg8051s.h"
//#include <stdlib.h>
//#include <stdio.h>
//#include <math.h>

#include "ClosedLoopDemomap.h"
#include "COREUARTAPB.H"
#include "CoreDAC_eval.h"

// main routine

void main (void)  {
	uint16 ctmp;
	uint16 DAC;
	uint16 SetPoint;
	uint16 CurrentVoltage;

	// initialize CoreUARTapb that communicates with PC
//	UART2_CTRL1 = 0x09; // baud-rate set to 115.2Kbaud (18.431MHz clock)
	UART2_CTRL1 = 0x04; // baud-rate set to 115.2Kbaud (9.816MHz clock)
	UART2_CTRL2 = 0x01; // no parity, 8-bit data

	// Set the default output to 1.5V
	DAC = 0x0C00;
	SetPoint = 0x05DC;

	// Print Menu
	PrintMenu();
    tx_str("Currently set to 1.5V...");
	tx_char(0x0d);tx_char('\n');

	// Infinite loop
	while (1) {
		// check if any characters have been received
		ctmp = rx_char();
		if (ctmp!=0xffff) {
			switch(ctmp) {
				// Check for up or down
				case '=' :
					if (SetPoint == 0x0FFF)
						{SetPoint = 0;}
					else 
						{SetPoint = SetPoint + 1;}
					PrintValues(SetPoint,DAC);
					break;
				case '-' :
					if (SetPoint == 0)
						{SetPoint = 0x0FFF;}
					else 
						{SetPoint = SetPoint - 1;} 
					PrintValues(SetPoint,DAC);
					break;
				case '0' : SetPoint = 0x0000; PrintValues(SetPoint,DAC); break;
				case '1' : SetPoint = 0x0100; PrintValues(SetPoint,DAC); break;
				case '2' : SetPoint = 0x0200; PrintValues(SetPoint,DAC); break;	    
				case '3' : SetPoint = 0x0300; PrintValues(SetPoint,DAC); break;
				case '4' : SetPoint = 0x0400; PrintValues(SetPoint,DAC); break;
				case '5' : SetPoint = 0x0500; PrintValues(SetPoint,DAC); break;
				case '6' : SetPoint = 0x0600; PrintValues(SetPoint,DAC); break;
				case '7' : SetPoint = 0x0700; PrintValues(SetPoint,DAC); break;
				case '8' : SetPoint = 0x0800; PrintValues(SetPoint,DAC); break;
				case '9' : SetPoint = 0x0900; PrintValues(SetPoint,DAC); break;
				case 'a' : SetPoint = 0x0a00; PrintValues(SetPoint,DAC); break;
				case 'b' : SetPoint = 0x0b00; PrintValues(SetPoint,DAC); break;
				case 'c' : SetPoint = 0x0c00; PrintValues(SetPoint,DAC); break;
				case 'd' : SetPoint = 0x0d00; PrintValues(SetPoint,DAC); break;
				case 'e' : SetPoint = 0x0e00; PrintValues(SetPoint,DAC); break;
				case 'f' : SetPoint = 0x0f00; PrintValues(SetPoint,DAC); break;
				case 'l' :
					PrintMean(DAC);
					PrintValues(SetPoint,DAC);
					break;
				case 'm' :
					PrintMenu();
					break;
				case '!' : 	// <Shift>-1
					DAC = 0x0F00; // Only get it close and let the algo do the rest
					SetPoint = 0x0384;  // 0900 Decimal
					SetDAC(DAC);
					tx_char(0x0d);tx_char('\n');
    				tx_str("Setting rail to 0.9V...");
					tx_char(0x0d);tx_char('\n');
					PrintValues(SetPoint,DAC);					
					break;
				case '@' : 	// <Shift>-2
					DAC = 0x0E10; // Only get it close and let the algo do the rest
					SetPoint = 0x044C;  // 1100 Decimal
					SetDAC(DAC);
					tx_char(0x0d);tx_char('\n');
    				tx_str("Setting rail to 1.1V...");
					tx_char(0x0d);tx_char('\n');
					PrintValues(SetPoint,DAC);	
					break;				
				case '#' :  // <Shift>-3
					DAC = 0x0C00; // Only get it close and let the algo do the rest
					SetPoint = 0x05DC;  // 1500 Decimal
					SetDAC(DAC);
    				tx_char(0x0d);tx_char('\n');
					tx_str("Setting rail to 1.5V...");
					tx_char(0x0d);tx_char('\n');
					PrintValues(SetPoint,DAC);
					break;
				case '$' :  // <Shift>-4 
					DAC = 0x0AC0; // Only get it close and let the algo do the rest
					SetPoint = 0x0708;  // 1800 Decimal
					SetDAC(DAC);
    				tx_char(0x0d);tx_char('\n');
					tx_str("Setting rail to 1.8V...");
					tx_char(0x0d);tx_char('\n');
					PrintValues(SetPoint,DAC);
					break;
				case '%' : 	// <Shift>-5
					DAC = 0x0700; // Only get it close and let the algo do the rest
					SetPoint = 0x09C4;  // 2500 Decimal
					SetDAC(DAC);
    				tx_char(0x0d);tx_char('\n');
					tx_str("Setting rail to 2.5V...");
					tx_char(0x0d);tx_char('\n');
					PrintValues(SetPoint,DAC);
					break;
				case '^' : 	// <Shift>-6
					DAC = 0x0300; // Only get it close and let the algo do the rest
					SetPoint = 0x0CE4;  // 3300 Decimal
					SetDAC(DAC);
    				tx_char(0x0d);tx_char('\n');
					tx_str("Setting rail to 3.3V...");
					tx_char(0x0d);tx_char('\n');
					PrintValues(SetPoint,DAC);
					break;
				default : break;
			}
		}
		// Need to set GPIO[15] and then clear GPIO[15] while maintaining
		// GPIO[11:0] for the DAC update to occur
		CurrentVoltage = get_avg_sample(DAC);
		if (CurrentVoltage > SetPoint + 1)
			DAC = DAC + 1;
		if (CurrentVoltage < SetPoint -1) 
			DAC = DAC - 1;
		SetDAC(DAC);
	}
}
